#!/bin/sh
# the next line restarts using wish \
exec wish "$0" -- "$@"
#########################################################
# Visual PPP interface
#
# Daniel Roche, <daniel.roche@bigfoot.com>
#
# Thanks to :
#
# Alain Labarthe <a.labarthe@free.fr> for spanish translation
# Peter Nikitser <Peter_Nikitser@health.qld.gov.au> for Gnome/KDE launcher
#
#########################################################

if { $tk_version < 8.0 } {
    puts "vppp need tcl/tk version 8.0 mininum , aborting !"
    exit
}

option add *highlightThickness 0
#option add *font -*-helvetica-medium-r-*-*-14-*-*-*-*-*-iso8859-1
option add *font 9x15bold
option add *wrapLength 600

#set tk_strictMotif 1

#########################################################
#
# global variable
#
#########################################################

variable Misc
set Misc(MainColor) "gray66"
set Misc(EntryColor) "gray72"
set Misc(HighColor1) "steelblue4"
set Misc(HighColor2) "skyblue4"
set Misc(ParIPSize) 154
set Misc(ParIPState) no
set Misc(Use+ua) no
set Misc(DoTime) 0
set Misc(CurTime) 0
set Misc(timcol,global) "#ff8000"
set Misc(timcol,cumul) "#00ff00"
set Misc(timcol,current) "#00c0ff"

tk_setPalette $Misc(MainColor)

variable Messages
variable ParamConn
variable ParamIP
variable Temp

variable Files
set Files(ConnectTraceFile) "/tmp/vppp-cf-[pid]"
set Files(KillTraceFile) "/tmp/vppp-kill-[pid]"
set Files(ErrorTraceFile) "/tmp/vppp-err-[pid]"
set Files(PppLogFile) "/var/run/ppp0.pid"
set Files(PppPapSecrets) "/etc/ppp/pap-secrets"
set Files(PppChapSecrets) "/etc/ppp/chap-secrets"
set Files(PppUpFile) "/etc/ppp/ip-up.d/vppp[pid]"
set Files(PppDownFile) "/etc/ppp/ip-down.d/vppp[pid]"
# zexec zkill begin by z to be sure they are executed AFTER vppp !
set Files(PppExecFile) "/etc/ppp/ip-up.d/zexec[pid]"
set Files(PppKillFile) "/etc/ppp/ip-down.d/zkill[pid]"
set Files(VpppRcFile) "~/.vppprc"

set Files(VpppLib) [ pwd ]
if ![ file exists [ file join $Files(VpppLib) script.proto ] ] {
    set Files(VpppLib) [ file join / usr local lib vppp]
    if ![ file isdirectory $Files(VpppLib) ] {
	set Files(VpppLib) [ file join / usr X11R6 lib X11 vppp ]
	if ![ file isdirectory $Files(VpppLib) ] {
	    puts "cannot find application directory $Files(VpppLib) !"
	    exit 1
	}
    }
}

#########################################################
#
# other files
#
#########################################################

source $Files(VpppLib)/tkgetdir.tcl
namespace import tkgetdir::*

source $Files(VpppLib)/balloon.tcl

source $Files(VpppLib)/mclistbox.tcl
namespace import mclistbox::*

source $Files(VpppLib)/combobox.tcl
namespace import combobox::*

source $Files(VpppLib)/errormsg.tcl

source $Files(VpppLib)/mscroll.tcl
mscroll Text
mscroll Listbox

#########################################################
#
# messages
#
#########################################################

proc InitDefaultMessages {} {
    global Messages

    set Messages(titre) "Visual PPP"
    set Messages(info) "Information"
    set Messages(conpar) "Connection parameters"
    set Messages(m0act) "Actions"
    set Messages(m0sit) "Sites"
    set Messages(m0opt) "Options"
    set Messages(m0hlp) "Help"
    set Messages(m1con) "Connect"
    set Messages(m1dec) "Disconnect"
    set Messages(m1load) "Load scripts"
    set Messages(m1save) "Save scripts"
    set Messages(m1xit) "Quit"
    set Messages(m2cre) "Create"
    set Messages(m2mod) "Edit"
    set Messages(m2del) "Delete"
    set Messages(m2scan) "Rescan"
    set Messages(m3lng) "Set language"
    set Messages(m3sdir) "Set scripts directory"
    set Messages(m3view) "View IP parameters"
    set Messages(m3hide) "Hide IP parameters"
    set Messages(m3tim1) "View global cumulated connection time"
    set Messages(m3tim2) "View by site cumulated connection time"
    set Messages(m3tim3) "View current connection time"
    set Messages(m3traz) "Reset connection time counters"
    set Messages(m4about) "About ..."
    set Messages(m4hlp1) "Manual"
    set Messages(m4gpl) "Copying"
    set Messages(par) "by"
    set Messages(msgok) " OK "
    set Messages(msgcan) "Cancel"
    set Messages(msgsvg) "Save"

    set Messages(lstnam) "site name"
    set Messages(lstdat) "date"

    set Messages(b_lst) "connection site list"
    set Messages(b_cl1) "connect"
    set Messages(b_cl2) "disconnect"
    set Messages(b_cl3) "abort"
    set Messages(b_hms) "connection time (HH:MM:SS)"
    set Messages(b_thm) "connection time (HHHH:MM)\nsince"
    set Messages(b_thg) "global\nconnection time (HHHH:MM)\nsince"
    
    set Messages(b_scr) "scripts list"
    set Messages(b_sfl) "script file"
    
    set Messages(interface) "Interface :"
    set Messages(devtty) "Line :"
    set Messages(speed) "Speed :"
    set Messages(localip) "Local IP :"
    set Messages(remoteip) "Remote IP :"
    
    set Messages(genp) "General Parameters"
    set Messages(snam) "Name :"
    set Messages(stel) "Phone :"
    set Messages(freq) "Modulation :"
    set Messages(typtel0) "Tone"
    set Messages(typtel1) "Pulse"
    set Messages(line) "Device :"
    set Messages(speed) "Speed :"
    set Messages(imod) "Modem init :"
    set Messages(ipadr) "IP address :"
    
    set Messages(logp) "Login authentification"
    set Messages(send1) "Send 1 :"
    set Messages(xpct1) "Expect 1 :"
    set Messages(send2) "Send 2 :"
    set Messages(xpct2) "Expect 2 :"
    set Messages(send3) "Send 3 :"
    set Messages(xpct3) "Expect 3 :"
    set Messages(send4) "Send 4 :"
    set Messages(xpct4) "Expect 4 :"
    
    set Messages(papp) "PAP/CHAP authentification"
    set Messages(user) "User account :"
    set Messages(pass) "Password :"
    
    set Messages(dnsp) "DNS configuration"
    set Messages(dnsa) "automatically set by server"
    set Messages(dnsm) "set manually as below :"
    set Messages(domn) "Domain name :"
    set Messages(dns1) "dns IP 1 :"
    set Messages(dns2) "dns IP 2 :"
    set Messages(dns3) "dns IP 3 :"
    
    set Messages(xtend) "Scripts ..."
    set Messages(xtitle) "Scripts edition"
    
    set Messages(htitle) "On line Help"
    
    set Messages(selsit) "Please select a site !"
    set Messages(delsit) "Do you really want to delete this site ?"
    set Messages(notread) "Impossible to read this script !"
    set Messages(notwrite) "Impossible to write this script !"
    set Messages(error) "Error"
    set Messages(warn) "Warning"
    set Messages(noconn) "Connection Error !"

    set Messages(lng)  "Language :"
    set Messages(sdir) "Script dirctory :"
    set Messages(parc) "Browse"

    set Messages(fdat) "%m/%d/%Y"
}

proc ReadMessagesFile {} {
    global Config Messages Files 

    set Lang [GetLang]

    if { ![ string compare $Lang "GB" ]} { 
	InitDefaultMessages
    } else {
	set flng [file join $Files(VpppLib) "message.$Lang" ]
	if [ file isfile $flng] {
	    set fid [ open $flng r]
	    set len [gets $fid line]
	    while {! [eof $fid]} {
		if { $len != 0 } {
		    if {! [regexp "^\[#!\]" $line ] } {
			set indx [string first ":" $line]
			if { $indx != -1 } {
			    set varname [ string range $line 0 [ expr $indx -1]]
			    set message [ string range $line [ expr $indx +1] end ]
			    set message [ string trimleft $message " " ]
			    if { $varname == "__font__" } {
				option add *font $message
			    } else {
				eval set Messages($varname) \"$message\"
			    }
			}
		    }
		}
		set len [gets $fid line]
	    }
	    close $fid
	} else {
	    InitDefaultMessages
	}
    }
} 

#########################################################
#
# pixmap creation
#
#########################################################

image create photo moi -data "\
R0lGODdhPwBkAPQAAAAAAP/w8P9rjf/EtEVtRVU7VaqJO//U/wDQ0KpZO/Lk5P/opI+2j6p4qlVH\
AFUjAP///wDAwKovPwDg4AAkAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACwAAAAA\
PwBkAAAF/iAjjmRpGASBLieZJkQhOw0Dl3iu72cs/ynVq5EqOIwyA6OQUu6eUEbRmJA4Eo9CliLz\
SQoJrawBI0bPrulRotL6slkk8tGIH48FdPT16MNnMlxiYn0yD0WHgzBMTnolBAuGP0ZZAHF2kpNZ\
U3EJRyqOJQ6CMmFfD5aSpERcFH8/D65vMqEkYmxhlwWCXJujda6kg0yxsbsUNbVMMEeJzbs/iwmt\
BQAUqa67PgCTbrUOMUcGTIYUvWKzANzc5tWE3JXGSWhH54uDXPBgDV/u6v7FzlnKt6sQiijkChVo\
gESQPi5SAla7ZozbD4fyAKWAciQMtxjjYEjIZpHAki3V/ipNhPVjYEpFWp7MAQMjDAGGWgRlgaFS\
3TV3BxjGiIHSkg8Chwgk2PFsYRebYWRww5KJYKqcPkq527KzlEkd0PosmZQ100UtFgPFIYcEKSlB\
QyUszeHgUgM8SsEozUvqDyox+VzFGUcuVZwYzHAQGAVtYbgCBhookRwWXJhcktRdGlpgQLe1eueS\
qEswj4EEZWqQmVYoAb+9Z6mFltO2CIqaOKBZStSAyNwAAVBkWipgwOrMXqMSKqvUNRMcBEk5GTAA\
OAMBVcguXWAcc+/U5UB7L6K0RLZXCxkcYAA8gPHTlyWcNj4gS8cFDIgQVUshDJ5DzoXhwjmTnCAA\
fgEs/pDgAAwYV0NkAxywwAKo3QNGAacwQd5+5MHwlRRSdUHOUtS1R12DwFHHIIPALdCbAXLNRYAV\
2VzooV4i5iECOFr0kU0CBgjAXnvtsTcAftUpCJyE3OUXmQ1MrKbfTTWNSIsIAcDmzj5HEmnikQcs\
6eWSC0jIIIwz9oaYZEQQ8UNdJAR3U4Fdjmnnne1JKFkVDJzgmpt5kPEYBR8y8EkREqCI56J2lrli\
gw0wGNWMkdlkzAiM2eFadYx2iieF1y3WBUgxsDNCAO1caACLnrY6poT5saEUGTj9hekuABSxqau8\
EokflKAIEYiOS5zDEIm9Jusiasu8gAixDqRlwAO7/ibLK35CLSWUVhSMUFBjC3Fqbav4TWrDnMQ8\
cOtUuwDZIANlljnup+em5u4kIxAAj0ky4KJhDQkqaWdQKBCwnpMAe0khEU8SwQJSHzZGEVe7MHRC\
DWGOiS15kN10mgEZW3cACkGJoFodxBZbqjUWUcsEGw1MOHCDFZ6LoVcCvydCZI2M0+2pXEwzRqTq\
HRmhZOLmqWCZYTad4HphxAxcMqrZYDJV5tFRTQIngnkAkwyGrPR6CMbb3rIZK4GaGb3l1wBEtqSa\
qHIEBABBAOtJrfB6A1yW34RfjxlpDa6psFRkRzySjwSUefZAmBBAUCbIXkqYIARhBNBA5AmY7asN\
/vrtY5KbJWxJXOdiDLmeAfKe/fQB4TAQOdkaU5hVDTfFAB0cMTu4wE1PT6je3gHAe8BSAbeu8baW\
tTFjCajK8GikYLYXqcAtDgl4q8fj9eeMdT8SB4PceZ2nEmITmX6nLoqowmuQiMKFA4ramV+EGlu7\
cEerngZZ8XHKht5e9S7siUlZN2oA3o6UgIOVjguruhN+Ivgqa42sFOyRF7xyAI0GSlAAAxSTAT01\
uWUoyHIAzIErlrK+4l3PVwnCm7LG0oAwKShmUHihxpCnPhtaq08yUFK89gAv+8UsfUxLlp4KsDQZ\
noEAdfIS10YYvF6xh3USCtyvoJAHKqKvcjJs/iGewtQgA24xClR0jfKaSEU8ZbB+Z9OD8ohEBjZ+\
bT29Et7wiOSI6nnJBg0EnOe4VzzuGHCDZ6jBHMtEBuNlMYNiVF/y1pMxBbFHD1hkzyMH8CThyfCE\
TfwU3jaIQkti0nhL2+CKyIZHPMYwknhLpbpcVAsoOlIEvhviAU9YPIVVcYMoO0QK0XATpt3vXRHK\
mOVOCEmBmTFBIPxI/ByRHkEis5JgjOHTfEXGUTYodcM8Aw2wKDz64AeUWbRkL2OpzUpOKFJ4MKUj\
IBS8azINhagc5NeWRsn7Ae+MegBF4GCVJB/KUH3q1Kb2kGQDgDpCKWA6Z9jKBMlX8lJMrmTm/rsS\
VAtvqZGS8cLf0zTJS3U6c5OA66gJIEFR8qVTeyIMYxULeU4RODQUN8Hl3x75yVFqU53dNKYubxrQ\
hUCojG/045IuGcOlUbSmX2NABFQqgv50xknqwY8Ng3o2DaaUo8Y8QASmStUOQopBZcQmO5nGzzdm\
VQF6HKtKTSIL1yghbLF0WvHwyFTj4bJMCmilVDs6AfUYojx3bV0Gf5q8dxXwAAqIrHqkSlZiOqCw\
DEBABCaBmgb5UGwkVQ/f/grZyCpgBGOtLBQIYI7CLgABsOvRTa7H1WbCKj99CptpI8vJCSwgtYVS\
DGMMNlUEIKBSO8GtIMvGyvzYtUG7NW2E/iYLXPopDhoUiABfEdCA09bhEMn4lVYRaQMU6Da6vFVC\
aqV6gFFVVTbZlat2GRBZ/Bz2T0RDK62UuwD0SncCYqXsWNvRl5zIYD1TDbBpYTWpJGxEZwzyb3RB\
9tupWrhY2G0MN8Z6MLnu9mAVikxvIFxaCfN2ZKlNcQSoQQ12FECsZNXuACS7W50+qIwmRq9nLSzf\
zQ7DxbtILYK1218TZzHHEh4AcXss1QyvY0tDnmyCIstKJO+2yP4VsIBTK5sQTWS97FlvdEVrZR3X\
twERqPB6x+pkL6eHw4NNc5FnfIAImxjLCpixaZnWYyHLpieocAWYK/w1GqvHynX2L4K19nxhielm\
EhSAsVwDnObAlvjOkC0yfU27ZRVvlsVbiU6c+RqACEz5tGXGs2QrTNlWi8DR1mhzfMEsV7xZ2sio\
znON8aZiATuEJaXJR1SnOkox5xq9l950YH+76F5/+tHtADIX0LzmOFPZynj+bacvPNUYgBrWgQDA\
fNfsYVXXmMaSTXGcPZ1hqVSkJVKRNKO7fWn0YhnG246zVEnhkp/4ozEE4LHAL2KSwJr4kvJtdbUf\
PawtpWUdcJ5AYVd8jMaAA62/MkIMeO3pgWu43S1jMbUt7O04uBgTgECJwgU+WIZ/XDZpEQQeeCGQ\
ioO6y+RmbxvCgpEQAAA7"

image create photo pppnoc -data "\
R0lGODlhQABAAOMAAAAAAM44EOZhIP+qAP//AICAgACAgICAAAAA/wAAgBI0VgCAAOptKK4oCP//\
//8AACH5BAEAAAoALAAAAABAAEAAAAT+UMlJq7046827/2AojmRpnmiqrmzrvnAsz3Rt33iu73wP\
FsBgwZcBOgyGIxJIpBgdCwdisZhSmcSCQym1Ur8LgE+73SISXjBVvCNDj1W1OsHGaQ3RuHxPtx+l\
W3t8C302boFqCAGLjF8JYYZlklQIlQcEA5mZi1SPdTKHUAsGaAiXDAQCBQCYA5yFoH+IlVIDBKgC\
rLkErYuwMAVJkrRUmakAAAy7q70BM3eSosXHBA3HBdSazjHBfwhlYMi3t8oAArkCmq7c3t9yAre7\
qfDo8LapwElJtNLwqAXn4M1bdY5XLmDtKn0z4E8ewF3wzBk8CKyKAYWV/BF4yGojA1SXDJDRQ8aN\
ykWFAh2eMwcyZEhkq0BVwaiR2kYBLV1+ZBCT20mUIHkdw0luZ7KPn/Ip1CIu6LidRpEB6AlqaRlk\
TqG+JAMkKTA0oZoWhblFiNevZKJcPUrWgZBVZ2FIBSep7VuSOuZueRDtbtwbeh3wdRsEbxMJyCR1\
/UsksQPDhzFAjky5suXLmDNr3sy5s+fPoEOLHv05AgA7"

image create photo pppcon -data "\
R0lGODlhQABAAIQAAAAAAIWdAM44EOZhIP+qAP//AJGFhXF5AJHCANrOzgDuhYCAgACAgH22AICA\
ALLOAG1hYerq6qHaAAAA/wAAgBI0VgCAAOptKK4oCKrmAP////8AAAAAAAAAAAAAAAAAACH5BAEA\
ABUALAAAAABAAEAAAAX+YCWOZGmeaKqubOu+cCybAGQDwKzLQOL7kNxuuOr9EgCFkMg0BX9JZXNK\
ghh6UWmzwe02AuCweEyuWK+KtHYX7iLeEglcPo/b7ZlM/Jxdy8BeXGSDhGFxAAZoaT0QMl9dYgeS\
k5SVlpNgFUiKRkgwj18BkplNRkFKUI0vAYKiAVQiT0idjKuCB6+wsVcJEFA+OUspXwihuiOIvMDA\
FQARwiesCKTHIslYzIgJVyoBxQcvC+LjCy7X2REJzyrE1CriGgwM8fLiLdqe2tzdARK57ws0aLCg\
YYIFCwYP2iuSL926FWCmrQhIr2DCgxgtQDsRzMC2jdH6/TtBUWBBChf+Mx4E6UQdSxNg/KUoSZAB\
QpUqKbyssrPElwwNUAS0OTAlzow6j3mTELTE0IICjx6lYCEpLDAZRoooGVXlBAFgw2Kk2nNGP6Yk\
uJo8OKGtgwIE4sYFe5CsLqwIHoxQe5AByglvLxQYsAAAXAJ0rV4N8CBvg6dd2xYkUEDwAMOXCxwG\
q5gKmAdAF8wzaXGghbiDcVzIXHizgGoVwkBei5FyZgypF6Q+jBj21nnzJtBeaVjwhdUABlweILc3\
7KeScQ6onHnw9OXTKQ9+Dry0aQvTBS9QPt16YeWaLz+PZ7GtcAbhq4/PPD15+stNjy1AyMB92/AF\
zGdYgMdVhsN1OLz+gYB+fflXnnzKJWfcBQBQiENheEmgy37+TQDgbgEOMCGFxx1XWGyMxQGLaB2K\
WJlmqblY4nEV0jgCVmhRwWJbAeHwomA/zmjhhUtgld8UC7hXkmovVjbjhQKJI8wBCAC1IUpq+Tgi\
lBqQIwxWWjWxAAUUEWSSahZSRE5h0PTDBQs13FAWDgCsRRqXa+JwApU5ptAJEGU1g4NJG5DWpZcv\
HdBAnxwdgYQfRQwqUKGHStmToow6QcsiPNRpkqUtePNmClZgoUagHHmqZ6iiHulEIn2gisKqLuAi\
kwp8qAGpbyg2IJEK15zaC683xvTFCptEQQuxYRQTZgmmJEGLKtVviOEsC7Lg8Au1nomxqDErlNrL\
L/mgWMi5hPgqRxj3wEpuMM/EEci8bsChIAJ3yBHKs366a0RHHzFV770EFwzJGDOc05BL5qJLBi7z\
EoEPwPsQGwMWzTgkq8XQNuNRxRzP4MtDIe8QRMkop6yyDCEAADs="

image create photo pppa1 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44ELLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4oCP//\
////AACAAOZhIJHCAICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAoALAAAAABAAEAAAAX+oCKOZGmeaKqubOu+cCzPdG3feK7vfO//wKBwSCwaj8ikcslswhLQaMKZ\
gjoMhisWSiVZHRAHBQIZk7nUhEMrNpPfEIBTvV5TFm44Wb6kg69lenoLfEhqBmGBgouEQAcnh2Jr\
i4wQjTyPjyZ+k3oUA6ChbwtxPgenmiKcdWQUrhMPBbKyoGSkhTmoBw8PI6tkBngUsAIPEQkAsQW1\
l5i7EgQBkZ2uYgUPxRHJ2ry0A825uw/R0ll1bWAQssYAAALcyMqgPZoM9tOsb9fcDewJ7MqWCUmQ\
JQuFfHuSFRPwDkAEbRFmCQQSqZqgCNi4GcMIEeM1YxQLoksHAWOxBA/NMW5E9pCXNopX2rg6aMCk\
RpTcMDp0+ZJiGQMzXZl8gDMZUYbY2nFsJ4HXKR4JgAVVefOhw4UC3LUDgIyB00w7ogalMBQg0QhY\
szJkiEyBrlQ5CI5Fi40XO7prGbrTO+KpD7mu1LSrW4xw3qxb27oNkmCmn3YLeR1uRwcKLsZ4Vg1O\
S3mNlMuY6YSpAxlx5c+gg2xlda6zAynIUhNZvQbBudeoqdB2YBu3ZdlM2p373QWFcAftiq9Irry5\
8+fQo0ufTr269evYs2vfzn17CAA7"

image create photo pppa2 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3feK7vfO//wKBwSCwaj8ikcslswhTQqIKI\
qCJe0MfhoN1CqVVW9hF5WCKRM/rbu1YfYZXi0TWr0fgIgGeFW60nc3R0Fgx3eWh7fH6AgYNlB2mI\
iAyKOwgQmRQoc5Fkh5N5lZdVEBMEFFcknWZ0oaEMEaM6CIwNJoKPiBYDvb54sZY5VQ0EqKuDyWgW\
zBUQBtDQvWjBPQ0NARMFI7muEQeGFs4CEBIKAM8G07M81wXaBazezGYGEOQS6PmZ0gPsO+4CxOOS\
jB4aaOUAABCw71y6XkCuNZCn62BCCA4SKrgYbYAQBVy4WKioBx05AQz+AUjIJyGauiCsDCKScG9f\
OZosadorBwSkFjveItAkp2AlzZvnVmbK1/Mns6dahtosuo+myqVMe6Y58JTZUAhU0YFFeU8hToUT\
0vpQgIbr06NTV6o8KWChQgDnrmUj0INtVwtfL4KVQLcuSpTnFrgzxgPkX8L3MiWEfBjlQssj9B7b\
4ZjZHIWRyYWuXPduYhENEARQtYC1DQVPcyk8mYm0QkFQhCGYAGFTY0PdHoAufJuOFGENJDfKoYCB\
oDKDZpfGfVzRHwjLddx9lKz4AynndDNy3WM7nQTJvlc38QaOCPI8zD9Arz63MPbZhShMZv8FfP0A\
0KGQEy4MSOCBCCYVqOCCDDbo4IMQRijhhBRWaOGFC4YAADs="

image create photo pppa3 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3feK7vfO//wKBwSEMQb8bkEQlBOI1L2RMa\
nTkjEWd1hs1qty6oswJTmM+KY6WBaDRaZsjhIJ+bh27CexWHSCAXEhKBgndAbhR7KQoQdYCEgpES\
AIcNeiqMjY0XDJCSgpQ+eYommX5yg5+fDKE8awFkJ4wHf6mqt6yiFASxJLOAjbe4Erk8bgGkIqbB\
nxcDz9CRDJOiBLy+mtmCF9wWEQbg4M+C0606xxQFI8t+EgedF94CERMKAN8G48XGDQXpFL+YcQNk\
IMK8CfcQYhE3YN8ONwVgKaCTbaAgcPQAABCg0B6+Z5UaBNQkqaBCBxn+FWTEl0/IRDnAmIG6N08A\
RwATEE4I1xLIL4ufJhhUSE+oTqEF6fmkQ2dgOwlC5ynIKbSovZxYEPqEya2rnKhEpyoUijOrVp+D\
DnTlFjWC2HtubRrUaFQjhbs+FAhS27Vq2Jw4awrYqBGAPXQEeuhde6HtSrcTBA+2adPeAojWeExk\
HNlgF52SbW4UPeLYtR2buTHS6Hlea8qiC1sWcayXDgVdTWmsiQX2YMONzJh7QAGW4k7sWEvWmAmN\
uWPJcihgkOmPpt2/mzs3d5mXbR2FSWZjHnz7CQQUEHzfEb5RgmwQ0NjjTsLJNSo92kN4H/+MRhRi\
PHGERtkIR199T2A6gd8QBELwHwttIKDgggweCCACjUwBBgxTULhhClpg6OGHAIowIokopqjiiiy2\
6OKLMMYo44w01thiCAA7"

image create photo pppa4 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3feK7vfH8jvmAJKNwBicSiDYGoHJPKGjPC\
rEZrjYjWep01Kw1Eo0sDU8Bh8qxRoYiZalnj/Hgp7nhF19wYs+4QBweBgndRfQR+KoAQEhAXEhKQ\
kYZCfRSKKAoQhI+TkaASAJYNiYucqBcMn6GRoz6ImSWbnI4Hkq2tDK88YAEVmoGOuLnFu7AUBMCz\
gY+1xbkMEsc8fQGyC7SouRcD3t+g0rw7pcok2qiNkhcXFhEG8PDekeI91hQFI+jqB6vtEQIiTFAA\
4J2BedSqNSiAj8KmQc/YPTIAUGDBCQUNektIbmEAhxBTXVAHzyIAARj+IxDUOIBUg4fp1EWimNKB\
RQUWDR5UomDQoJHPXBUMKAAlgAkYJ8TbKQSmxFwTAKYUGDVpVIoCm/r0FDRqQAVIo1IliFQLxqbN\
2KkN5HUq2JRRj5rFSKGppANq2XlViTSjgqIAAcjFCICCYR8KIuFVK9Zt3wlEBZwUDIDgPQI9Eue9\
sDcn38iSixYluKBPAQKYd/TcDLmi2aOgi56UPcKaOdWLL2wSXDFgb9GyKZMWYW2ZarXaBBPVAlxy\
ZU53xj2g8Cvzqn28QQumlWecNWw4FDCg5QiVcufcu48rrcz4Dsrb0m2Hrv7E9Ns+4HNKEDMPwfUk\
PFABfkHoBwF/ENRkp4KABBYhWDrRAXjCHBW4F8WDEAjmwiUVxrGAhi88UAp4Hp4AhxhhYFJiC0iI\
oQyJK5rARBhgxMjiFFzYiEIVWlARBhQ6yjgFjEGKgAAnRxS5AhxKusBkk1BGKeWUVFZppQ8hAAA7"

image create photo pppa5 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3TyK3Deb7/JoRQCCyShJGhzwhEEpm/RqMS\
SUJ3lWlFubzOspVs4yGE9LwyrZQs6qJf6kfjbctSxHTblCLN6+8PLwqDhAp5dn0sgxAHB4yNg29S\
BHMrixASEBcSEpuckVdSfJYQj5qenKkSAKENlCoKpbIXDKiqnKxMk5UnsaWZB523twy5RVkBFSix\
wZi2w6rFuhQEyiXMmr/QwwwS0kVSAbwjvrLDFwPp6qndxkCu1STlspidFxcWEQb7++mc7UbCUShA\
jl69A7XwRRAQYYICAPoM+PsGrkGBgRWwabunycDChhAnQIyYjuI7i8n+FDiix5HTPpAABIiM8JDk\
gFYNNJpL5XGmA5AKQEaUiEYlo2zacEFkKEAmgAkiJ/AjegVby1sTFs5smDVqVo8NqzpyxLGehKwM\
FUDNyvUh1Coiqx69R5cR2q1qZ2Z9ClekNSYKOh2gew8tTagjFTRdCICvSAAUIgPmNJguW7yIJzAV\
ELMxgIcCCRgJTPiCYaGHN3Nu2vThAikFCIgGorK05o9wn6puGpP3iHDxaFe+EKvxR4bHWfP27FpE\
uL8/FNAt15hpFeWcP5ca5O4BhWSja82DYFx1Y1+F3IUbF52Br0yyqmdHn97d62rQf3g2R+/89von\
eBccE/uVkoBBhTyDZB8JD1QwIBQFQnAgBACq0OCDXjRGD3cLntDAHfmhoSF5HXr4YRh+jNAYDHK8\
kuIMUlQwyosxSOFKFjTCYOMd7OXYRhs+2Hhijz4uwIWQDuJRJAoIVCEjAXwksiSQRhpZRRI2TqnC\
EA0gQKSWIwixhRlgsnBGmVu6geaabLbp5pszhAAAOw=="

image create photo pppa6 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3bCJnf/Jr/vaAKgYDshMJKBRGJFI9IW2OK\
UDqdxmhtquwumUSo1lVpdKcN4gM4jpWV08cjbRK3VeZyY36y31N5ew1/N2UUeoQ3ZhRTiYqHDy8K\
k5QKjoaNLJMQBwecnZOEUwSDK5sQEhAXEhKrrKFtU4ymEJ+qrqy5EgCxDaQqCrXCFwy4uqy8WqOl\
J8G1qQetx8cMyUhlARUowdGoxtO61coUBNol3KrP4NMMEuJIUwHMI87C0xcD+fq57dZCvuVI1BOG\
qtWFCxYiGFi4MB+rflHiUShAj2DBA8UQRhAQYYICAAoNOHwHr0GBiRX+0Kk7qMrAxo4gJ4AMmY/k\
P5PZFHgiyJLVQpgABMiM8JHmgF4NVNrL5XKoA5gKYIYU+Ucnp3TqkIHkKEAogAkyJzCk2gZdz2MT\
Ng7tmDZsWpcdy3ryxLKghLQcFYBNy/Yj2CYyy149SJgT3rV6h6b9ClimOS0KWh0gfBAvUbAzFXTd\
CICxTAAUQkNmNZkwX8SYJ3AVELQzgI8SCUSJTPmCZamXV7Pu2vXjgikFCMgWorO26peAv+ruGpT5\
iHgBiZe+EKzzS47XeTN37VtEvMdBFBCu15lrE+2sX9ea5O8BhWyziw2EYF13Z2eV/MWbF56Bs1TC\
lJcefvn581s54AWe4Zo9BN23XoEnuBedFgvWkoBFlXxkIAkPVDDhGBVCcCEEEKrQ4Yd3dEYQexue\
0MAhCf6hIn0tuviiEo6Q0BkMc/ySIw1czPKjDGiUw9+QI/jxmyxlINmHjUwe6SQUCKDBhZFSDhlG\
GlVWWQE5jGTiZJIQOBGGcAQcgsaYJYTRRBhVWskmCmCY2cWcQ4SBpwtP7PnCDkr6KeighBZKQwgA\
Ow=="

image create photo pppa7 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3fKILvrs7/J50PeKsYjxUEIqIcEmGN6JFC\
JRAoTOezJUVWooiGMtvcrr7HaPTBbi/fWnMJ/W2woyQhRClfNYxrDSlNQn0nf18PgoMLZYYmXxR1\
PY+HFRR4lTUNkg8vCqChCpWRmSugEAcHqaqghlEEiyqoEBIQFxISuLmuZlGYpxCst7u5xhIAvg2x\
s8LOFwzFx7nJT7CyJgrOtge609MM1UBfARUo2t210t/H4dYUBOYl6LfC7OwMEu5AUQHYItqc1Zp2\
YYDBg8byifuxLB6JgAIHXphoIYKBixcN5lJIpB+FAiMg2pNwINqFigL+IkxQAMCiAY37+DUo8JEC\
vZETbxmIkHJCS58RXBqMyXBmAJurBObMdVElAAACgLIUOkBZg5vbjO0E6sCpAqcuX/ZRsGrVhazU\
WqYUEBXABJ8TMIo1Q2/ptAk8garECxfvTpV0yxIbKQFvSgVv8e5l+TaoT7qpiE08e8CwXsRA8bp1\
7JMCXV0HJk80HAFzy9JseT7l+5SKZyIKcoWerPjyW7drBUB9CoClRwKwdYkmDbb0hNy62bJluSBK\
AStAyIq+cJxnUKfVlbOFun1EP4c/pE/U9tR6SvPadfNmLqKfvPCTIT5dGzT904CgFj6gUA52NJEQ\
lIfcfcKIslA//+y8oAADAdnizHzq4WfgQs3F894PvG0jEIEQiMIShSLsB94TGQqTQEQePpXCAxWM\
uEWJEJzYYSgqqsCii3I8JVB+IB4iyYWG6Bhgj4dwYoQmI9TogiLMIDmDFMA4GYMa8SQopQpqSGJl\
H3ywoIaRW5rRxB4pfPlHlWFuQYgSZpp5yRVqSDlGUAhc4ZoVeGppiiY+jIEAFX/+WMeXV4rQxHVs\
KuIFkFciIIwjhbawJqSRqhBHpT1ciummnHa6QwgAOw=="

image create photo pppa8 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPtIvUuHwjd+63vJ8Q1VvwjkNZZcmsNJ7QiDSY\
dEGZlCyBkEUQENIItap6NpfQ9JMnRkCK5JKTmX7Y7/gjMm6aOxt2Tyx6fCYNaIANg0Y9cIWHTg+K\
hTlOFH+UPocUgpk5DZcPLwqkpQqeC5adK6QQBweur6SZTwSTKq0QEhAXEhK9vrN8T5ysELG8wL7L\
EgDDDba4x9MXDMrMvs5ktbcmCtO7B7/Y2AzaSU4BFSjf4rrX5Mzm2xQE6yXtvMfx8QwS80meBOgm\
4ts0XdguDFjIcJm/c0Og2SNh8CDCCxgtRDDAkeNCXw+rCKRQYETFfRL+Dli7oFFAhAkKAGw08BFg\
wAYFSFbIhxIjLwMRXE6QOVSKxwE2I+JUpwDWQZ++OL4EAEBA0ZgzFz5rwBPcMqBFHUxVMHUmTUpN\
XelDmU2mSwFWAUwYOqHjWT75oGKbELToS750+QJ9iRcWLJ8IJfB1qWAu378x50oZilctxsuuFvtt\
XJSv3MlD75FR8OvAZYyLI3CWqRpuUKqAqWahMNqX6cuPN8+V+1ZAVaoAYo4kUIX06Qupy6qe0Ns3\
XLgxFzwpsCVJ0+PMg4ah2xxuVe8jBE4cch3jN6raXaZ/7h14dBECRQtRcLki1bdS2PsOfowUxAcU\
qFOcNSdBgF5zVBnDZApEAhH0gwIMGLTLNPftp+CCEElnj3xCAAfOQQn2h+EJAI5HhofHJGCRKTFl\
SMIDFZgYB4oQqAjBiCrAKGMhVB3kn4sngLIEKiL0aCCQQQrJoSdUwSBJNETSYEYxmTgCAxT2OFhF\
EVauAMUlWm7ZpZdfOoEKEmOgoEaMmFCywxRqxJlGBfVwsgofekyBQAUIaDFbPVtsAeadhbw5BQV9\
/pkFHWpESQIPDSAQpyRnLEnkDkY4OgOmmnbq6aeghipqqCEAADs="

image create photo pppa9 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPNI3UeIzc/J3/q93CByySbpFdxPiqOJ+VhnRK\
RUAQSSETNX1SvgQCWAxGELDoHXG7kEKd1HhVmdWyo0/qY8/v+5VobCN4UQ17UjA9a1sNcIYNMj6S\
go1RD5A4i0xRFIWCRo0UiJ9FDZ0PLwqqqwqkJJyjK6oQBwe0taqubQ0EmCqzEBIQFxISxMW5n1Ki\
shC3w8fF0hIAyry+JwrO2xcM0dPF1WxSvSnazsIHxuDgDOKbDQEVKNrqwd/s0+7jFATzJfWGocvH\
joGEfUykBMAm4tw2dhcGSJwozeA7UGH+NdzGsdiFjxYiGBg5UmIxi4z+4lEoMMLhwAPeLoQUEGGC\
AgAiDZhEmLBBgZUVAg78OMxABJoTcCaNkFMiT1A+5SmwxZFosZE1AQAQsPRm0wHWGgh9KM3oUgdZ\
FWTNqdPVVFoCB4bDSVMAVwATkk4g2fZTQKvgJhxdWlOwXsFGa/q1ZYtosGKCaSrIK7jwzbxMk/qF\
+7EzrciEJy8VjDdzUo1bFBg70Plj5AiiccK2e1SrYa1fKLBRLYF158qh8+KtK2CrVgA3FfZLbaz1\
67WwJxAvbtfuzV0FwjCZ2vqC9KNMs36vbndr+REK/W33fUGbVvA04ZMvfvy6CIWogSjo7FBrXabz\
aXWOKhc9QIE8qXnP4xIE700noDOsXKQQQ/oxcI4w2/hH34ARXtSGP/kBcdxDHD0IASs3eSiCgeoJ\
MqIzCXB0YocpPFBBi5+8CEGMMxKoYgk24uiKVhz52IIpTuhCApEM/njCMkkquaSTKFxSjpQ1uMEM\
ljNM4Q+FP9iBwxSdgJmJGkNkSWYUglhBhCYqxHGjJ1uogYUceOZZQT+ixGKEm1jUgQAUuZExRhhi\
FGImEGqEl9ujkH6RRxxKNopAnnpUAgWXdqbJ5Qw8fGrDCGKK+gKcpqaq6qqslhACADs="

image create photo pppa10 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdG3feK63yNLvQJ8PASH+gqOKcllpOJ/QqBOB\
iESMyOeSwiUQul+wd0ygViPFY87JVErfUsTUatY1l9CHfs/v+x9majh3TQ16TjY9R4I0DW6GDTuM\
No5ND5FIdg0UhZk7jhSInjqbFQ8vCqmqCqMkTaGYK6kQBwe0tamtC04EsSmzEBIQFxISxMW5nk6h\
shC3w8fF0hIAyg29KgrO2xcM0dPF1VnXviXazsIHxuDgDOJATQEVKNrqwd/s0+5ZFATz5rSGocvH\
joGEfUCcBCi34Nw2dhcGSJwozeC7T17+iXC4LZixCxcsRDBAkqTEYhb+gyikUGAER48HvIWMICDC\
BAUARho4iTBhgwIsK9R7+HGYAZo2c07IqVNiz08/5Smw1RGkR5JJAQhYGgFn0wHWGgztOO0oVwdJ\
FSTVubPV1IAXiIbLWVPAVgATlk4o2dbTUKvsJtDkalOwXsFHbfq1ZcuqRwmCayrIK7gwzrxWlvqF\
C9LqgciEJ3MVjDfzUo1BFBg70Blk5K55mSqwSxNA6aUAuFBAoloC686VQ8eeUFeAVtsAcK4kkPoj\
cKRrYRc3btcuzl0/vQCZ2voCcehJv1e3q5X8CIX+tv++oM020prvxxtHfl2EQtQ5FHR2aLuuFfm2\
nZPKRQ9QIE9q3rzJ5N50ATqzykUKMYSDAgycI8w2/c0n4IMX7eIPfjkg91BHDUKwCk4dilBgepmI\
6EwCHZnIYQoPVMCiJy5CAKOMA6ZYQo03tmJbRz22UAqIowwJgW0uLKOELiYw+cIl2EBJCSgS1jDJ\
ldc0AYQipDiZZQw/BIIDFJyMSWYgaTQChY2dSELHFXDUGUUF/cCi5ppUWFEBAm0woVsYYniRpihf\
9vknFbo16qhueESRiSJnNCCHnU9cEqiVZlqZCBWehirqqKSWauqpSIQAADs="

image create photo pppa11 -data "\
R0lGODlhQABAAIQAAAAAAKrmAOptKM44EKHaALLOAP+qAACAgP8A//8AAICAgBI0VgAAgIWdAK4o\
CHF5AP//////AACAAOZhIJHCAH22AICAAAAA/wAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAACH5BAEA\
AAsALAAAAABAAEAAAAX+4CKOZGmeaKqubOu+cCzPdK0idh4jOK7/KJ8PSDT1eLxiZcmsNJ7QqHSK\
gEQiSCCUSekSCF5w+EsmBxDnK1ZoezaX07g8yrtWhzMnM/ro+/+AgYAiSUk0ek4NfU9FhW1wig1F\
hAt4Mw1wD5KTRE4UiZxFmBSMoUQNnw8vCqytCqYlnqUrrBAHB7a3rLAiTwSbKrUQEhAXEhLGx7um\
T6S0ELnFycfUEgDMDb/B0NwXDNPVx9ecvsAmCtzEB8jh4QzjSg0BFSjo68Pg7dXv5BQE9CXsFYOm\
Tx8DCfxEyTMnAh23YeEuDJhIkdpBeKe+AGz4MB2yCxcsRDBAkuTEYxf+Jz0JQKHACIceD3wLGUFA\
hAkKAIw0cDKhwgItKwgk+LGYgZo3dU7QuXOiz1MNCsxTgOshSIgkkwIQsDRCzqYDsDUY6vHY0a4O\
kipIupMnL6q2BhIVp9OmAK4AJiydUNKtKYFX202o2fXm4L2Dj978iwvXVYgSBttUoHew4Zx6ryz9\
GxekZ1uSC1PuOjiv5qUbJylAdsAzSMle9TJVcLcmANNLAXShwGm1hNaeLYuWPcGugK23AeRc6U/1\
x+BI2cY2fvzu3ZwLnhT4UoSq6wvFoycNb/3uVvMjVv7rDvwCuttIbcYvfzw59l7yUv9Q4BnmbbtX\
0HebQ6xg9AAF86jY9g1M0MBH3YDQuILRSgztx4BDxHDzX30ESohRdv/o90Ny6TwEIQSu5PShCAeu\
FwqJ0CTQUYq3pfBABS6aAiMEMqLYSo0q3JgjL7c9VOCKJ6CyBC8lFAkBkCw0sySTTSJpYzYVUhmD\
G85oSQMU/2TZgiWhQPGJmCvwAEEPZZrpRA1IGKJFFDiCsgMSWGCR3Rx8zlGBP6TM8gKeea7xxqFv\
7CbGGF+cKeigldSxBg+H7mbppZfuIcUPcfrQJ5+aHAqEEEOQ6WWakbJ5Kg1yrurqq7DGKuusI4QA\
ADs="

#########################################################
#
# widget creation
#
#########################################################

proc CreateWidgets {} {
    global Messages Misc Config Args

    wm title . $Messages(titre) 
    if { [info exists Args(geom)] } {
	wm geometry . $Args(geom)
    }
    if { [info exists Args(iconic)] } {
	wm iconify . 
    }
    if { [info exists Args(hidden)] } {
	wm withdraw . 
    }

    menu .mbar -tearoff 0 -type menubar

    .mbar add cascade -menu .mbar.act -label $Messages(m0act) 
    menu .mbar.act -tearoff 0
    
    .mbar.act add command -label $Messages(m1con) -command "Connect"
    .mbar.act add command -label $Messages(m1dec) -command "Disconnect"
    .mbar.act add separator
    .mbar.act add command -label $Messages(m1load) -command "ScriptsLoad"
    .mbar.act add command -label $Messages(m1save) -command "ScriptsSave"
    .mbar.act add separator
    .mbar.act add command -label $Messages(m1xit) -command "VpppExit"

    .mbar add cascade -menu .mbar.site -label $Messages(m0sit) 
    menu .mbar.site -tearoff 0

    .mbar.site add command -label $Messages(m2cre) -command "Create"
    .mbar.site add command -label $Messages(m2mod) -command "Modify"
    .mbar.site add command -label $Messages(m2del) -command "Delete"
    .mbar.site add separator
    .mbar.site add command -label $Messages(m2scan) -command "GetSiteList"

    .mbar add cascade -menu .mbar.opts -label $Messages(m0opt) 
    menu .mbar.opts -tearoff 0

    .mbar.opts add command -label $Messages(m3lng) -command "SetLng"
    .mbar.opts add command -label $Messages(m3sdir) -command "SetScriptDir"
    .mbar.opts add separator
    .mbar.opts add radiobutton -variable Config(timode) -value "global" \
	    -selectcolor $Misc(timcol,global) -label $Messages(m3tim1) \
	    -command "ViewTime global"
    .mbar.opts add radiobutton -variable Config(timode) -value "cumul" \
	    -selectcolor $Misc(timcol,cumul) -label $Messages(m3tim2) \
	    -command "ViewTime cumul"
    .mbar.opts add radiobutton -variable Config(timode) -value "current" \
	    -selectcolor $Misc(timcol,current) -label $Messages(m3tim3) \
	    -command "ViewTime current"
    .mbar.opts add command -label $Messages(m3traz) -command "RazTime"
    .mbar.opts add separator
    .mbar.opts add command -label $Messages(m3view) -command "ViewIP"
    .mbar.opts add command -label $Messages(m3hide) -command "HideIP"

    .mbar add cascade -menu .mbar.help -label $Messages(m0hlp) 
    menu .mbar.help -tearoff 0

    .mbar.help add command -label $Messages(m4about) -command "Apropos"
    .mbar.help add separator
    .mbar.help add command -label $Messages(m4hlp1) \
	    -command "Help $Messages(m4hlp1) manual"
    .mbar.help add separator
    .mbar.help add command -label $Messages(m4gpl) \
	    -command "Help $Messages(m4gpl) GPL"

    . configure -menu .mbar

    frame .main -borderwidth 2 -relief raised
    pack .main -side top -fill both -expand 1

    frame .main.fl 
    frame .main.fb 
    pack .main.fb -side right -fill y -padx 4 -pady 4
    pack .main.fl -side left -expand 1 -fill both -padx 4 -pady 4

    mclistbox .main.fl.lst -yscrollcommand ".main.fl.sbv set" \
	    -height 4 -width 32 \
	    -background $Misc(EntryColor) \
	    -selectbackground $Misc(HighColor1) \
	    -selectforeground white \
	    -selectmode browse \
	    -exportselection 0 \
	    -labelbackground $Misc(MainColor) \
	    -fillcolumn nam \
	    -labelanchor nw \
	    -labelfont 6x12 
    .main.fl.lst column add nam -label $Messages(lstnam) 
    .main.fl.lst column add dat -label $Messages(lstdat) -width 12
    .main.fl.lst column add dat0 -visible 0
    .main.fl.lst label bind nam <ButtonPress> "SortList nam"
    .main.fl.lst label bind dat <ButtonPress> "SortList dat0"

    bind .main.fl.lst <ButtonRelease> "SetList"

    scrollbar .main.fl.sbv -orient vertical -width 12 -command ".main.fl.lst yview"
    pack .main.fl.sbv -side left -fill y -padx 0 -pady 0
    pack .main.fl.lst -side right -expand 1 -fill both -padx 0 -pady 0

    frame .main.fb.mmss -relief sunken -borderwidth 2
    label .main.fb.mmss.l -text "--------" -background black \
	    -foreground white -font 8x13bold
    button .main.fb.clic -image pppnoc -command "DoIt"
    pack .main.fb.mmss -side top -fill x -padx 0 -pady 2
    pack .main.fb.clic -side bottom -expand 1 -fill both -padx 0 -pady 0
    pack .main.fb.mmss.l -fill both

    bind .main.fb.mmss.l <Double-Button-1> "ViewTime"

    frame .parip -borderwidth 2 -relief raised

    set vinterf ""
    set vdev ""
    set vspeed ""
    set vlocip ""
    set vremip ""

    set phaut 30

    frame .parip.f0 -relief flat -height $phaut
    pack .parip.f0 -fill x -pady 0
    label .parip.f0.l0 -text $Messages(interface) -relief flat -anchor e
    label .parip.f0.v0 -text $vinterf -relief sunken -background $Misc(EntryColor) \
	    -textvariable ParamIP(if) -anchor w
    place .parip.f0.l0 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4
    place .parip.f0.v0 -relx 0.50 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4

    frame .parip.f1 -relief flat -height $phaut
    pack .parip.f1 -fill x -pady 0
    label .parip.f1.l1 -text $Messages(devtty) -relief flat -anchor e
    label .parip.f1.v1 -text $vdev -relief sunken -background $Misc(EntryColor) \
	    -textvariable ParamIP(dev) -anchor w
    place .parip.f1.l1 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4
    place .parip.f1.v1 -relx 0.50 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -heigh -4

    frame .parip.f2 -relief flat -height $phaut
    pack .parip.f2 -fill x -pady 0
    label .parip.f2.l2 -text $Messages(speed) -relief flat -anchor e
    label .parip.f2.v2 -text $vspeed -relief sunken -background $Misc(EntryColor) \
	    -textvariable ParamIP(speed) -anchor w
    place .parip.f2.l2 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4
    place .parip.f2.v2 -relx 0.50 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4

    frame .parip.f3 -relief flat -height $phaut
    pack .parip.f3 -fill x -pady 0
    label .parip.f3.l3 -text $Messages(localip) -relief flat -anchor e
    label .parip.f3.v3 -text $vlocip -relief sunken -background $Misc(EntryColor) \
	    -textvariable ParamIP(locip) -anchor w
    place .parip.f3.l3 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4
    place .parip.f3.v3 -relx 0.50 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4

    frame .parip.f4 -relief flat -height $phaut
    pack .parip.f4 -fill x -pady 0
    label .parip.f4.l4 -text $Messages(remoteip) -relief flat -anchor e
    label .parip.f4.v4 -text $vremip -relief sunken -background $Misc(EntryColor) \
	    -textvariable ParamIP(remip) -anchor w
    place .parip.f4.l4 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4
    place .parip.f4.v4 -relx 0.50 -x 2 -relwidth 0.50 -width -4 \
	    -y 2 -relheight 1.0 -height -4

    set_balloon .main.fb.clic $Messages(b_cl1) 1
    #set_balloon .main.fl.lst $Messages(b_lst) 

    ViewTime refresh

    # trap appli closed by WM
    bind .main <Destroy> VpppExit
}

############################################################"

proc CreateConParams {xtend} {
    global ParamConn Misc Messages Files

    set hbg $Misc(HighColor1)
    set hfg "white"
    set habg $Misc(HighColor2)
    set hsc "darkgoldenrod1"

    if [ winfo exists .conx ] {
	return
    }
    toplevel .conx
    wm title .conx $Messages(conpar) 

    frame .conx.f -borderwidth 2 -relief raised 
    frame .conx.b -borderwidth 2 -relief raised 

    label .conx.f.tgen -text $Messages(genp) -background $hbg -foreground $hfg -anchor w
    pack .conx.f.tgen -side top -fill x 
    frame .conx.f.fgen -borderwidth 2 -relief groove
    pack .conx.f.fgen -side top -fill x 
    label .conx.f.fgen.lnam -text $Messages(snam) 
    entry .conx.f.fgen.enam -background $Misc(EntryColor) 
    .conx.f.fgen.enam delete 0 end
    .conx.f.fgen.enam insert end $ParamConn(name)
    grid .conx.f.fgen.lnam -row 0 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.enam -row 0 -column 1 -sticky we -pady 1
    label .conx.f.fgen.ltel -text $Messages(stel) 
    entry .conx.f.fgen.etel -background $Misc(EntryColor) 
    .conx.f.fgen.etel delete 0 end
    .conx.f.fgen.etel insert end $ParamConn(phone)
    grid .conx.f.fgen.ltel -row 1 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.etel -row 1 -column 1 -sticky we  -pady 1
    label .conx.f.fgen.lfrq -text $Messages(freq) 
    eval "set tmp \$Messages\(typtel$ParamConn(freq)\)"
    menubutton .conx.f.fgen.mfrq -text $tmp -relief raised -indicatoron 1 \
	    -menu .conx.f.fgen.mfrq.m 
    menu .conx.f.fgen.mfrq.m -tearoff 0
    .conx.f.fgen.mfrq.m add command -label $Messages(typtel0) \
	    -command "SetMenuButton .conx.f.fgen.mfrq {$Messages(typtel0)}"
    .conx.f.fgen.mfrq.m add command -label $Messages(typtel1) \
	    -command "SetMenuButton .conx.f.fgen.mfrq {$Messages(typtel1)}"
    grid .conx.f.fgen.lfrq -row 2 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.mfrq -row 2 -column 1 -sticky w  -pady 1

    label .conx.f.fgen.lline -text $Messages(line) 
    entry .conx.f.fgen.eline  -background $Misc(EntryColor)
    .conx.f.fgen.eline delete 0 end
    .conx.f.fgen.eline insert end $ParamConn(line)
    grid .conx.f.fgen.lline -row 3 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.eline -row 3 -column 1 -sticky we -pady 1
    label .conx.f.fgen.lspd -text $Messages(speed) 
    menubutton .conx.f.fgen.mspd -text $ParamConn(speed) -relief raised -indicatoron 1 \
	    -menu .conx.f.fgen.mspd.m 
    menu .conx.f.fgen.mspd.m -tearoff 0
    .conx.f.fgen.mspd.m add command -label "115200" \
	    -command "SetMenuButton .conx.f.fgen.mspd 115200"
    .conx.f.fgen.mspd.m add command -label "57600" \
	    -command "SetMenuButton .conx.f.fgen.mspd 57600"
    .conx.f.fgen.mspd.m add command -label "38400" \
	    -command "SetMenuButton .conx.f.fgen.mspd 38400"
    .conx.f.fgen.mspd.m add command -label "19200" \
	    -command "SetMenuButton .conx.f.fgen.mspd 19200"
    .conx.f.fgen.mspd.m add command -label "9600" \
	    -command "SetMenuButton .conx.f.fgen.mspd 9600"
    .conx.f.fgen.mspd.m add command -label "4800" \
	    -command "SetMenuButton .conx.f.fgen.mspd 4800"
    .conx.f.fgen.mspd.m add command -label "1200" \
	    -command "SetMenuButton .conx.f.fgen.mspd 1200"
    grid .conx.f.fgen.lspd -row 4 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.mspd -row 4 -column 1 -sticky w -pady 1
    label .conx.f.fgen.limod -text $Messages(imod) 
    #entry .conx.f.fgen.eimod  -background $Misc(EntryColor)
    combobox .conx.f.fgen.eimod -background $Misc(EntryColor) \
	-command "ParseModemInitString" -width 30
    .conx.f.fgen.eimod delete 0 end
    .conx.f.fgen.eimod insert end $ParamConn(modem)

    set flng [file join $Files(VpppLib) "modeminit.txt" ]
    if [ file isfile $flng] {
	set fid [ open $flng r]
	set len [gets $fid line]
	while {! [eof $fid]} {
	    if { $len != 0 } {
		if {! [regexp "^\[#!\]" $line] } {
		    .conx.f.fgen.eimod list insert end $line
		}
	    }
	    set len [gets $fid line]
	}
	close $fid
    }

    grid .conx.f.fgen.limod -row 5 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.eimod -row 5 -column 1 -sticky we -pady 1
    label .conx.f.fgen.lipad -text $Messages(ipadr) 
    entry .conx.f.fgen.eipad  -background $Misc(EntryColor)
    .conx.f.fgen.eipad delete 0 end
    .conx.f.fgen.eipad insert end $ParamConn(ipadr)
    grid .conx.f.fgen.lipad -row 6 -column 0 -sticky e -pady 1
    grid .conx.f.fgen.eipad -row 6 -column 1 -sticky we -pady 1

    grid columnconfigure .conx.f.fgen 1 -weight 1

    checkbutton .conx.f.tlog -text $Messages(logp) -anchor w \
	    -background $hbg -foreground $hfg \
	    -activebackground $habg -activeforeground $hfg \
	    -selectcolor $hsc \
	    -relief flat -command "ToggleLogin"
    pack .conx.f.tlog -side top -fill x 
    frame .conx.f.flog -borderwidth 2 -relief groove
    if { $ParamConn(login) == "yes" } {
	pack .conx.f.flog -side top -fill x 
	.conx.f.tlog select
    } else {
	.conx.f.tlog deselect
    }
    label .conx.f.flog.lsnd1 -text $Messages(send1) 
    entry .conx.f.flog.esnd1 -background $Misc(EntryColor) 
    .conx.f.flog.esnd1 delete 0 end
    .conx.f.flog.esnd1 insert end $ParamConn(send1)
    grid .conx.f.flog.lsnd1 -row 0 -column 0 -sticky e -pady 1
    grid .conx.f.flog.esnd1 -row 0 -column 1 -sticky we -pady 1
    label .conx.f.flog.lxpk1 -text $Messages(xpct1) 
    entry .conx.f.flog.expk1 -background $Misc(EntryColor) 
    .conx.f.flog.expk1 delete 0 end
    .conx.f.flog.expk1 insert end $ParamConn(xpect1)
    grid .conx.f.flog.lxpk1 -row 1 -column 0 -sticky e -pady 1
    grid .conx.f.flog.expk1 -row 1 -column 1 -sticky we -pady 1
    label .conx.f.flog.lsnd2 -text $Messages(send2) 
    entry .conx.f.flog.esnd2 -background $Misc(EntryColor) 
    .conx.f.flog.esnd2 delete 0 end
    .conx.f.flog.esnd2 insert end $ParamConn(send2)
    grid .conx.f.flog.lsnd2 -row 2 -column 0 -sticky e -pady 1
    grid .conx.f.flog.esnd2 -row 2 -column 1 -sticky we -pady 1
    label .conx.f.flog.lxpk2 -text $Messages(xpct2) 
    entry .conx.f.flog.expk2  -background $Misc(EntryColor)
    .conx.f.flog.expk2 delete 0 end
    .conx.f.flog.expk2 insert end $ParamConn(xpect2)
    grid .conx.f.flog.lxpk2 -row 3 -column 0 -sticky e -pady 1
    grid .conx.f.flog.expk2 -row 3 -column 1 -sticky we -pady 1
    label .conx.f.flog.lsnd3 -text $Messages(send3) 
    entry .conx.f.flog.esnd3  -background $Misc(EntryColor)
    .conx.f.flog.esnd3 delete 0 end
    .conx.f.flog.esnd3 insert end $ParamConn(send3)
    grid .conx.f.flog.lsnd3 -row 4 -column 0 -sticky e -pady 1
    grid .conx.f.flog.esnd3 -row 4 -column 1 -sticky we -pady 1
    label .conx.f.flog.lxpk3 -text $Messages(xpct3) 
    entry .conx.f.flog.expk3  -background $Misc(EntryColor)
    .conx.f.flog.expk3 delete 0 end
    .conx.f.flog.expk3 insert end $ParamConn(xpect3)
    grid .conx.f.flog.lxpk3 -row 5 -column 0 -sticky e -pady 1
    grid .conx.f.flog.expk3 -row 5 -column 1 -sticky we -pady 1
    label .conx.f.flog.lsnd4 -text $Messages(send4) 
    entry .conx.f.flog.esnd4 -background $Misc(EntryColor) 
    .conx.f.flog.esnd4 delete 0 end
    .conx.f.flog.esnd4 insert end $ParamConn(send4)
    grid .conx.f.flog.lsnd4 -row 6 -column 0 -sticky e -pady 1
    grid .conx.f.flog.esnd4 -row 6 -column 1 -sticky we -pady 1
    label .conx.f.flog.lxpk4 -text $Messages(xpct4) 
    entry .conx.f.flog.expk4  -background $Misc(EntryColor)
    .conx.f.flog.expk4 delete 0 end
    .conx.f.flog.expk4 insert end $ParamConn(xpect4)
    grid .conx.f.flog.lxpk4 -row 7 -column 0 -sticky e -pady 1
    grid .conx.f.flog.expk4 -row 7 -column 1 -sticky we -pady 1

    grid columnconfigure .conx.f.flog 1 -weight 1

    checkbutton .conx.f.tpap -text $Messages(papp) -anchor w \
	    -background $hbg -foreground $hfg \
	    -activebackground $habg -activeforeground $hfg \
	    -selectcolor $hsc \
	    -relief flat -command "TogglePAP"
    pack .conx.f.tpap -side top -fill x 
    frame .conx.f.fpap -borderwidth 2 -relief groove
    if { $ParamConn(pap) == "yes" } {
	pack .conx.f.fpap -side top -fill x 
	.conx.f.tpap select
    } else {
	.conx.f.tpap deselect
    }
    label .conx.f.fpap.lusr -text $Messages(user) 
    entry .conx.f.fpap.eusr  -background $Misc(EntryColor)
    .conx.f.fpap.eusr delete 0 end
    .conx.f.fpap.eusr insert end $ParamConn(user)
    grid .conx.f.fpap.lusr -row 0 -column 0 -sticky e -pady 1
    grid .conx.f.fpap.eusr -row 0 -column 1 -sticky we -pady 1
    label .conx.f.fpap.lpass -text $Messages(pass) 
    entry .conx.f.fpap.epass  -background $Misc(EntryColor) -show "*"
    .conx.f.fpap.epass delete 0 end
    .conx.f.fpap.epass insert end $ParamConn(pass)
    grid .conx.f.fpap.lpass -row 1 -column 0 -sticky e -pady 1
    grid .conx.f.fpap.epass -row 1 -column 1 -sticky we -pady 1

    grid columnconfigure .conx.f.fpap 1 -weight 1

    checkbutton .conx.f.tdns -text $Messages(dnsp) -anchor w \
	    -background $hbg -foreground $hfg \
	    -activebackground $habg -activeforeground $hfg \
	    -selectcolor $hsc \
	    -relief flat -command "ToggleDNS"
    pack .conx.f.tdns -side top -fill x 
    frame .conx.f.fdns -borderwidth 2 -relief groove
    if { $ParamConn(dns) == "yes" } {
	pack .conx.f.fdns -side top -fill x 
	.conx.f.tdns select
    } else {
	.conx.f.tdns deselect
    }
    radiobutton .conx.f.fdns.rm1 -text $Messages(dnsa) -anchor w \
	    -variable ParamConn(dnsmode) -value "auto"
    radiobutton .conx.f.fdns.rm2 -text $Messages(dnsm) -anchor w \
	    -variable ParamConn(dnsmode) -value "manu"
    grid .conx.f.fdns.rm1 -row 0 -column 0 -columnspan 3 -sticky w -pady 1
    grid .conx.f.fdns.rm2 -row 1 -column 0 -columnspan 3 -sticky w -pady 1
    label .conx.f.fdns.spc -text " " 
    label .conx.f.fdns.ldom -text $Messages(domn) 
    entry .conx.f.fdns.edom -background $Misc(EntryColor)
    .conx.f.fdns.edom delete 0 end
    .conx.f.fdns.edom insert end $ParamConn(domain)
    grid .conx.f.fdns.spc -row 2 -column 0 -sticky we -pady 1
    grid .conx.f.fdns.ldom -row 2 -column 1 -sticky e -pady 1
    grid .conx.f.fdns.edom -row 2 -column 2 -sticky we -pady 1
    label .conx.f.fdns.ldns1 -text $Messages(dns1) 
    entry .conx.f.fdns.edns1 -background $Misc(EntryColor)
    .conx.f.fdns.edns1 delete 0 end
    .conx.f.fdns.edns1 insert end $ParamConn(dns1)
    grid .conx.f.fdns.ldns1 -row 3 -column 1 -sticky e -pady 1
    grid .conx.f.fdns.edns1 -row 3 -column 2 -sticky we -pady 1
    label .conx.f.fdns.ldns2 -text $Messages(dns2) 
    entry .conx.f.fdns.edns2 -background $Misc(EntryColor)
    .conx.f.fdns.edns2 delete 0 end
    .conx.f.fdns.edns2 insert end $ParamConn(dns2)
    grid .conx.f.fdns.ldns2 -row 4 -column 1 -sticky e -pady 1
    grid .conx.f.fdns.edns2 -row 4 -column 2 -sticky we -pady 1
    label .conx.f.fdns.ldns3 -text $Messages(dns3) 
    entry .conx.f.fdns.edns3 -background $Misc(EntryColor)
    .conx.f.fdns.edns3 delete 0 end
    .conx.f.fdns.edns3 insert end $ParamConn(dns3)
    grid .conx.f.fdns.ldns3 -row 5 -column 1 -sticky e -pady 1
    grid .conx.f.fdns.edns3 -row 5 -column 2 -sticky we -pady 1

    grid columnconfigure .conx.f.fdns 1 -weight 1

    pack .conx.f -expand 1 -fill both -side top
    pack .conx.b -fill x -side bottom
    
    button .conx.b.ok -text $Messages(msgok) -command "OkConParam"
    if { $xtend } {
	button .conx.b.xtend -text $Messages(xtend) -command "AdvancedEdit $ParamConn(name)"
    }
    button .conx.b.can -text $Messages(msgcan) -command "CancelConParam"

    pack .conx.b.ok -side left -padx 10 -pady 4
    if { $xtend } {
	pack .conx.b.xtend -side right -padx 10 -pady 4
	set_balloon .conx.b.xtend $Messages(xtitle) 
    }
    pack .conx.b.can -side right -padx 10 -pady 4
}

#########################################################
#
# fonctions
#
#########################################################

proc Apropos {} {
 global Messages

 if [ winfo exists .apropos ] {
     return
 }
 toplevel .apropos
 label .apropos.ver -text "$Messages(titre) version 3.8" -font 12x24
 label .apropos.by -text $Messages(par) 
 label .apropos.ico -image moi
 label .apropos.txt -text "Daniel Roche"
 label .apropos.mail -text "mailto:daniel.roche@bigfoot.com" -font 6x10
 label .apropos.web -text "http://daniel.roche.free.fr/" -font 6x10
 button .apropos.clic -text "clic" -command "destroy .apropos" -highlightthickness 0

 wm title .apropos $Messages(info) 
 pack .apropos.ver .apropos.by .apropos.ico \
      .apropos.txt .apropos.mail .apropos.web .apropos.clic -pady 4
}

proc FatalError {msg} {
    global Messages

    tk_messageBox -title $Messages(error) -message $msg -icon error -type ok \
		-parent .
    exit
}

proc ShowError {msg} {
    global Messages

    toplevel .verror
    label .verror.msg -text $msg
    button .verror.ok -text $Messages(msgok) -command "destroy .verror" \
	    -highlightthickness 0
    pack .verror.msg .verror.ok -pady 4

    wm title .verror $Messages(error) 
    wm transient .verror .
    set x [expr [winfo rootx .main.fb.clic] - 200]
    set y [expr [winfo rooty .main.fb.clic] + 40]
    wm geometry .verror +${x}+${y}
}

#############################################
# GUI callback functions
#############################################

proc VpppExit {} {
    global Files

    WriteConfig
    if [ file exists $Files(ConnectTraceFile) ] {
	file delete $Files(ConnectTraceFile)
    }
    if [ file exists $Files(KillTraceFile) ] {
	file delete $Files(KillTraceFile)
    }
    if [ file exists $Files(ErrorTraceFile) ] {
	file delete $Files(ErrorTraceFile)
    }
    if [ file exists $Files(PppKillFile) ] {
	file delete $Files(PppKillFile)
    }
    if [ file exists $Files(PppExecFile) ] {
	file delete $Files(PppExecFile)
    }
    DeleteIPUpDownScripts
    exit
}

proc SetList {} {
    ViewTime refresh
}

proc GetSelectedSite {} {
    set isel [.main.fl.lst curselection]
    if { $isel == "" } {
	return {}
    } else {
	set elem [.main.fl.lst get $isel]
	return [lindex $elem 0 ]
    }
}

proc Connect {} {
    global Misc

    switch -exact $Misc(ConState) {
	"no" {
	    DoConnect
	    return
	}
	"in" {
	    puts "already connecting"
	    return
	}
	"yes" {
	    puts "already connected"
	    return
	}
	"out" {
	    puts "please wait for disconnecting"
	    return
	}
    }
    puts "should not happen"
}

proc Disconnect {} {
    global Misc

    switch -exact $Misc(ConState) {
	"no" {
	    puts "already disconnected"
	    return
	}
	"in" {
	    AbortConnect
	    return
	}
	"yes" {
	    DoDisconnect
	    return
	}
	"out" {
	    puts "already disconnecting"
	    return
	}
    }
    puts "should not happen"
}

proc Create {} {
    InitNewConnection
    CreateConParams 0
}

proc Modify {} {
    global Messages

    set sitnam [GetSelectedSite]
    if { $sitnam == "" } {
	tk_messageBox -title $Messages(error) -message $Messages(selsit) \
		-icon error -type ok -parent .main.fl.lst
	return
    }
    set err [ReadConnectionFiles $sitnam]
    if { $err != "" } {
	tk_messageBox -title $Messages(error) -message "$Messages(notread)\n$err" \
		-icon error -type ok -parent .main.fl.lst
    } else {
	CreateConParams 1
    }
}

proc Delete {} {
    global Messages Files ParamConn Config

    set sitnam [GetSelectedSite]
    if { $sitnam == "" } {
	tk_messageBox -title $Messages(error) -message $Messages(selsit) \
		-icon error -type ok -parent .main.fl.lst
	return
    }
    set res [tk_messageBox -title $Messages(warn) -message $Messages(delsit) \
	    -icon question -type okcancel -parent .main.fl.lst]

    if { $res == "ok" } {
	set filbase [ file join $Config(scriptdir) $sitnam ]
	set filchat [ file join $Config(scriptdir) $sitnam.chat ]
	set filpap [ file join $Config(scriptdir) $sitnam.pap ]
	
	ReadConnectionFiles $sitnam

	file delete $filbase $filchat $filpap
	
	EditPapSecretsFile del $ParamConn(user) $ParamConn(pass)
	RedoPapSecretsFile

	if { [info exists Config(timcumul,$sitnam)] } {
	    unset Config(timcumul,$sitnam)
	}
	if { [info exists Config(datcumul,$sitnam)] } {
	    unset Config(datcumul,$sitnam)
	}

	GetSiteList
    }
}

proc DoIt {} {
    global Misc

    switch -exact $Misc(ConState) {
	"no" {
	    DoConnect
	    return
	}
	"in" {
	    AbortConnect
	    return
	}
	"yes" {
	    DoDisconnect
	    return
	}
	"out" {
	    puts "already disconnecting"
	    return
	}
    }
    puts "should not happen"
}

proc ViewIP {} {
    global Misc

    if { $Misc(ParIPState) == "no" } {
	set gstr [wm geometry .]
	scan $gstr "%dx%d+%d+%d" w0 h0 x0 y0
	set h1 [ expr $h0 + $Misc(ParIPSize) ]
	set nstr [format "%dx%d" $w0 $h1]
	wm geometry . $nstr
	pack .parip -side bottom -fill x 
	set Misc(ParIPState) "yes"
    }
}

proc HideIP {} {
    global Misc

    if { $Misc(ParIPState) == "yes" } {
	set gstr [wm geometry .]
	scan $gstr "%dx%d+%d+%d" w0 h0 x0 y0
	set h1 [ expr $h0 - $Misc(ParIPSize) ]
	set nstr [format "%dx%d" $w0 $h1]
	wm geometry . $nstr
	pack forget .parip
	set Misc(ParIPState) "no"
    }
}

proc OkConParam {} {
    global Messages

    GetConnectionParams
    set err [CreateConnectionFiles]
    if { $err != "" } {
	tk_messageBox -title $Messages(error) -message "$Messages(notwrite)\n$err" \
		-icon error -type ok -parent .main.fl.lst
    } else {
	destroy .conx
	GetSiteList
    }
}

proc CancelConParam {} {
    destroy .conx
}

proc SetMenuButton {widget entry} {
    $widget configure -text $entry
}

proc ToggleLogin {} {
    global ParamConn

    if { $ParamConn(login) == "no" } {
	pack .conx.f.flog -side top -fill x -after .conx.f.tlog
	set ParamConn(login) "yes"
    } else {
	pack forget .conx.f.flog
	set ParamConn(login) "no"
    }
}

proc TogglePAP {} {
    global ParamConn

    if { $ParamConn(pap) == "no" } {
	pack .conx.f.fpap -side top -fill x -after .conx.f.tpap
	set ParamConn(pap) "yes"
    } else {
	pack forget .conx.f.fpap
	set ParamConn(pap) "no"
    }
}

proc ToggleDNS {} {
    global ParamConn

    if { $ParamConn(dns) == "no" } {
	pack .conx.f.fdns -side top -fill x -after .conx.f.tdns
	set ParamConn(dns) "yes"
    } else {
	pack forget .conx.f.fdns
	set ParamConn(dns) "no"
    }
}

proc SortList {by} {
    global Config

    set w .main.fl.lst

    set data [$w get 0 end]
    set index [lsearch -exact [$w column names] $by]
    
    if { $by == "dat0" } {
	set sens "-decreasing"
	set stype "-integer"
    } else {
	set sens "-increasing"
	set stype "-ascii"
    }
    set result [lsort -index $index $sens $stype $data]

    $w delete 0 end
    eval $w insert end $result
    set Config(sortby) $by
}

proc ParseModemInitString {win newval} {
    if [regexp "(.*) \\(.*\\)" $newval m0 m1] {
	set minitstr $m1
    } else {
	set minitstr $newval
    }
    $win delete 0 end
    $win insert end $minitstr
}

#############################################
# connexion state management 
#############################################
proc DoConnect {} {
    global Misc Messages

    set sitnam [GetSelectedSite]
    if { $sitnam == "" } {
	tk_messageBox -title $Messages(error) -message $Messages(selsit) \
		-icon error -type ok -parent .main.fl.lst
	return
    }
    if { $Misc(ConState) != "no" } {
	puts "cannot begin connection when not disconnected"
	return
    }
    AnimStart con
    TimeStart
    set_balloon .main.fb.clic $Messages(b_cl3) 1
    set Misc(ConState) "in"
    set Misc(CurrentSite) $sitnam

    DoConnScript $sitnam
    WaitForConnected
}

proc DoDisconnect {} {
    global Misc Messages

    if { $Misc(ConState) != "yes" } {
	puts "cannot begin disconnection when not connected"
	return
    }
    AnimStart noc
    TimeStop
    set_balloon .main.fb.clic $Messages(b_cl1) 1
    set Misc(ConState) "out"

    DoDisconnScript
    WaitForDisconnected
}

proc AbortConnect {} {
    global Misc Messages Args Files

    if { $Misc(ConState) != "in" } {
	puts "cannot abort connection when not connecting"
	return
    }
    AnimStop
    TimeStop
    set_balloon .main.fb.clic $Messages(b_cl1) 1
    set Misc(ConState) "no"
    .main.fb.clic configure -image pppnoc
    set Misc(CurTime) 0
    set Misc(CurrentSite) ""
    TimeShow
    DeleteIPUpDownScripts
    # if autokill mode , abortconnect will also kill vppp
    if { [info exists Args(autokill)] } {
	close [open $Files(KillTraceFile) w]
    }
}

proc SetConnected {} {
    global Misc Messages

    if { $Misc(ConState) != "in" } {
	puts "cannot set connected when not connecting"
	return
    }
    AnimStop
    TimeStop
    TimeStart
    set_balloon .main.fb.clic $Messages(b_cl2) 1
    .main.fb.clic configure -image pppcon
    set Misc(ConState) "yes"
    ViewIP
    SurveyConnection
}

proc SetDisconnected {} {
    global Misc Messages

    if { $Misc(ConState) != "out" } {
	puts "cannot set disconnected when not disconnecting"
	return
    }
    AnimStop
    TimeStop
    set_balloon .main.fb.clic $Messages(b_cl1) 1
    .main.fb.clic configure -image pppnoc
    set Misc(ConState) "no"
    set Misc(CurrentSite) ""
    HideIP
    DeleteIPUpDownScripts
    GetSiteList
}

#############################################
# icon animation
#############################################
proc AnimStart {sens} {
    global Misc
 
    if { $sens == "con" } {
      set Misc(DoAnim) 1
      AnimNext 1
    } else {
      set Misc(DoAnim) 11
      AnimNext -1
    }
}

proc AnimNext {incr} {
    global Misc

    if { $Misc(DoAnim) } {
	.main.fb.clic configure -image pppa$Misc(DoAnim)
	incr Misc(DoAnim) $incr
	if [ expr $Misc(DoAnim) <= 0 ] {
	    set Misc(DoAnim) 11
	}
	if [ expr $Misc(DoAnim) >= 12 ] {
	    set Misc(DoAnim) 1
	}
	after 200 AnimNext $incr
    }
}

proc AnimStop {} {
    global Misc

    set Misc(DoAnim) 0
}

#############################################
# timer animation
#############################################
proc TimeStart {} {
    global Misc
 
    set Misc(DoTime) [clock seconds]
    set Misc(CurTime) 0
    TimeNext
}

proc TimeNext {} {
    global Misc Config

    if { $Misc(DoTime) } {
        set now [clock seconds]
	set last $Misc(CurTime)
        set Misc(CurTime) [expr $now - $Misc(DoTime)]
	if { $Misc(ConState) == "yes" } {
	    set incr [expr $Misc(CurTime) - $last]
	    set Config(timcumul) [expr $Config(timcumul) + $incr]
	    if [ string length $Misc(CurrentSite) ] {
		if { ! [info exists Config(timcumul,$Misc(CurrentSite))] } {
		    set Config(timcumul,$Misc(CurrentSite)) 0
		}
		set Config(timcumul,$Misc(CurrentSite)) \
			[expr $Config(timcumul,$Misc(CurrentSite)) + $incr]
	    }
	}
	TimeShow
	after 1000 TimeNext
    }
}

proc TimeStop {} {
    global Misc

    set Misc(DoTime) 0
}

proc TimeShow {} {
    global Config Misc

    if { $Config(timode) == "current" } {
	set secs $Misc(CurTime) 
    } elseif { $Config(timode) == "global" } {
	set secs $Config(timcumul)
    } else {
	set sitnam [GetSelectedSite]
	if { $sitnam == "" } {
	    set secs ""
	} else {
	    if { [info exists Config(timcumul,$sitnam)] } {
		set secs $Config(timcumul,$sitnam)
	    } else {
		set Config(timcumul,$sitnam) 0
		set secs 0
	    }
	}
    }

    if [ string length $secs ] {
	set hh [expr $secs / 3600]
	set tmp [ expr $secs - $hh*3600 ]
	set mm [expr $tmp / 60]
	set ss  [ expr $tmp - $mm*60 ]
    }
    
    if { $Config(timode) == "current" } {
	set fmt [format "%02d:%02d:%02d" $hh $mm $ss]
    } elseif { $Config(timode) == "global" } {
	set fmt [format "%5d:%02d" $hh $mm]
    } else {
	if [ string length $secs ] {
	    set fmt [format "%5d:%02d" $hh $mm]
	} else {
	    set fmt "-----:--" 
	}
    }
    .main.fb.mmss.l configure -text $fmt
}

proc ViewTime { {mode "loop" }} {
    global Config Messages Misc

    if { $mode == "loop" } {
	if { $Config(timode) == "current" } {
	    set Config(timode) "global"
	} elseif { $Config(timode) == "global" } {
	    set Config(timode) "cumul"
	} else { 
	    set Config(timode) "current"
	}
    }

    .main.fb.mmss.l configure -foreground $Misc(timcol,$Config(timode))

    if { $Config(timode) == "current" } {
	set_balloon .main.fb.mmss.l $Messages(b_hms) 1
    } elseif { $Config(timode) == "global" } {
	set tmpd [clock format $Config(datcumul) -format $Messages(fdat)]
	set_balloon .main.fb.mmss.l "$Messages(b_thg) $tmpd" 1
    } else { 
	set sitnam [GetSelectedSite]
	if { $sitnam == "" } {
	    set_balloon .main.fb.mmss.l "$Messages(selsit)" 1
	} else {
	    if { ! [info exists Config(datcumul,$sitnam)] } {
		set Config(datcumul,$sitnam) [clock seconds]
	    }
	    set tmpd [clock format $Config(datcumul,$sitnam) -format $Messages(fdat)]
	    set_balloon .main.fb.mmss.l "$sitnam:\n$Messages(b_thm) $tmpd" 1
	}
    }
    TimeShow
}

proc RazTime {} {
    global Config Misc

    set now [clock seconds]

    set Misc(CurTime) 0
    
    foreach cnm [array names Config timcumul*] {
	set Config($cnm) 0
    }
    foreach cnm [array names Config datcumul*] {
	set Config($cnm) $now
    }

    TimeShow
}

#############################################
# site managment ( real work)
#############################################
proc GetSiteList {} {
    global Files Config Messages Misc
    
    if { ! [file isdirectory $Config(scriptdir)] } {
	file mkdir $Config(scriptdir)
    }

    .main.fl.lst delete 0 end

    set curwd [pwd]
    cd $Config(scriptdir)
    set flst [glob -nocomplain *]
    foreach fil $flst {
	if { [regexp "\\.(chat|pap)$" $fil] } {
	    continue
	} else {
	    set atim1 [file atime $fil]
	    set atim2 [clock format $atim1 -format $Messages(fdat)]
	    .main.fl.lst insert end [list $fil $atim2 $atim1]
	}
    }
    cd $curwd

    SortList $Config(sortby)

    # ?? should not be necessary
    .main.fl.lst conf -selectbackground $Misc(HighColor1)
    .main.fl.lst conf -selectforeground white
}

proc InitNewConnection {} {
    global ParamConn
    
    set ParamConn(name) "site_xxx"
    set ParamConn(phone) ""
    set ParamConn(freq) "0"
    set ParamConn(line) "/dev/modem"
    set ParamConn(speed) "115200"
    set ParamConn(modem) "AT"
    set ParamConn(ipadr) ""
    set ParamConn(login) "no"
    set ParamConn(send1) ""
    set ParamConn(xpect1) "ogin:"
    set ParamConn(send2) "the_login"
    set ParamConn(xpect2) "word:"
    set ParamConn(send3) "the_password"
    set ParamConn(xpect3) ""
    set ParamConn(send4) ""
    set ParamConn(xpect4) ""
    set ParamConn(pap) "no"
    set ParamConn(user) ""
    set ParamConn(pass) ""
    set ParamConn(dns) "no"
    set ParamConn(dnsmode) "none"
    set ParamConn(domain) ""
    set ParamConn(dns1) ""
    set ParamConn(dns2) ""
    set ParamConn(dns3) ""
}

proc CreateConnectionFiles {} {
    global ParamConn Misc Files Config
    
    set filbase [ file join $Config(scriptdir) $ParamConn(name) ]
    set filchat [ file join $Config(scriptdir) $ParamConn(name).chat ]
    set filpap [ file join $Config(scriptdir) $ParamConn(name).pap ]
    set filproto [ file join $Files(VpppLib) script.proto ]

    # create script file 
    set fid ""
    catch {set fid [ open $filbase w 0777]} err
    if { $fid == "" } {
	return $err
    }
    puts $fid "#!/bin/sh"
    puts $fid "#"
    puts $fid "# Vppp script for site: $ParamConn(name)"
    puts $fid "#"
    puts $fid ""
    puts $fid "DEVICE=$ParamConn(line)"
    puts $fid "SPEED=$ParamConn(speed)"
    puts $fid "IPADDR=$ParamConn(ipadr)"
    puts $fid "CHATFILE=$filchat"
    if { $ParamConn(pap) == "yes" } {
	if [ string compare $Misc(Use+ua) "no" ] {
	    puts $fid "PAP=\"+ua $filpap\""
	} else {
	    puts $fid "PAP=\"user $ParamConn(user)\""
	}
    }
    if { $ParamConn(dns) == "yes" } {
	if { $ParamConn(dnsmode) == "auto" } {
	    puts $fid "DNSMODE=auto"
	} else {
	    puts $fid "DNSMODE=manu" 
	    if { $ParamConn(domain) != "" } {
		puts $fid "DOMAIN=$ParamConn(domain)"
	    }
	    if { $ParamConn(dns1) != "" } {
		puts $fid "DNS1=$ParamConn(dns1)"
	    }
	    if { $ParamConn(dns2) != "" } {
		puts $fid "DNS2=$ParamConn(dns2)"
	    }
	    if { $ParamConn(dns3) != "" } {
		puts $fid "DNS3=$ParamConn(dns3)"
	    }
	}
    }
    puts $fid ""
    set fid2 ""
    catch {set fid2 [open $filproto r]} err
    if { $fid2 == "" } {
	close $fid
	return $err
    }
    fcopy $fid2 $fid
    close $fid2
    close $fid

    # create chat file 
    set fid ""
    catch {set fid [ open $filchat w 0666]} err
    if { $fid == "" } {
	return $err
    }
    puts $fid "REPORT"
    puts $fid "CONNECT"
    puts $fid "ABORT"
    puts $fid "BUSY"
    puts $fid "ABORT"
    puts $fid "ERROR"
    puts $fid "ABORT"
    puts $fid "BLACKLISTED"
    puts $fid "ABORT"
    puts $fid "\"NO CARRIER\""
    puts $fid "ABORT"
    puts $fid "\"NO DIALTONE\""
    puts $fid "ABORT"
    puts $fid "\"NO ANSWER\""
    puts $fid "\"\""
    puts $fid "$ParamConn(modem)"
    puts $fid "OK"
    puts -nonewline $fid "ATD"
    if { $ParamConn(freq) } {
	puts -nonewline $fid "P"
    } else {
	puts -nonewline $fid "T"
    }
    puts $fid "$ParamConn(phone)"
    puts $fid "CONNECT"
    if { $ParamConn(login) == "yes" } {
	foreach key {send1 xpect1 send2 xpect2 send3 xpect3 send4 xpect4} {
	    if { $ParamConn($key) == "" } { 
		puts $fid "\"\""
	    } elseif [regexp " " $ParamConn($key)] {
		puts $fid "\"$ParamConn($key)\""
	    } else {
		puts $fid "$ParamConn($key)"
	    }
	}
    }
    close $fid

    # create pap file 
    if { $ParamConn(pap) == "yes" } {
	# create first local(saved) pap file
	set fid ""
	catch {set fid [ open $filpap w 0666]} err
	if { $fid == "" } {
	    return $err
	}
	puts $fid "$ParamConn(user)"
	puts $fid "$ParamConn(pass)"
	close $fid

	if { ! [string compare $Misc(Use+ua) "no"]} {
	    # modify general pap-secrets file
	    set err [ EditPapSecretsFile mod $ParamConn(user) $ParamConn(pass) ]
	    if [ string length $err ] {
		return $err
	    }
	}
    }

    return ""
}

proc ReadConnectionFiles {sitnam} {
    global ParamConn Files Config
    
    set ParamConn(name) $sitnam

    set filbase [ file join $Config(scriptdir) $sitnam ]
    set filchat none
    set filpap none

    set ParamConn(pap) "no"
    set ParamConn(dns) "no"
    set ParamConn(dnsmode) "none"
    set ParamConn(domain) ""
    set ParamConn(dns1) ""
    set ParamConn(dns2) ""
    set ParamConn(dns3) ""

    # read script file 
    set fid ""
    catch {set fid [ open $filbase r]} err
    if { $fid == "" } {
	return $err
    }
    while { ! [ eof $fid ] } {
	gets $fid line
	if [regexp "^DEVICE=(.*)" $line m0 m1] {
	    set tmp0 [string index $m1 0]
	    if { $tmp0 == "/" }  {
		set ParamConn(line) $m1
	    } else {
		set ParamConn(line) [file join / dev $m1]
	    }
	} elseif [regexp "^SPEED=(.*)" $line m0 m1] {
	    set ParamConn(speed) $m1
	} elseif [regexp "^IPADDR=(.*)" $line m0 m1] {
	    set ParamConn(ipadr) $m1
	} elseif [regexp "^CHATFILE=(.*)" $line m0 m1] {
	    set filchat $m1
	} elseif [regexp "^PAP=\"\\+ua (.*)\"" $line m0 m1] {
	    set ParamConn(pap) "yes"
	    set filpap $m1
	} elseif [regexp "^PAP=\"(name|user) (.*)\"" $line m0 m1 m2] {
	    set ParamConn(pap) "yes"
	    set ParamConn(user) $m2
	} elseif [regexp "^DNSMODE=(.*)" $line m0 m1] {
	    set ParamConn(dns) "yes"
	    set ParamConn(dnsmode) $m1
	} elseif [regexp "^DOMAIN=(.*)" $line m0 m1] {
	    set ParamConn(dns) "yes"
	    set ParamConn(dnsmode) "manu"
	    set ParamConn(domain) $m1
	} elseif [regexp "^DNS1=(.*)" $line m0 m1] {
	    set ParamConn(dns) "yes"
	    set ParamConn(dnsmode) "manu"
	    set ParamConn(dns1) $m1
	} elseif [regexp "^DNS2=(.*)" $line m0 m1] {
	    set ParamConn(dns) "yes"
	    set ParamConn(dnsmode) "manu"
	    set ParamConn(dns2) $m1
	} elseif [regexp "^DNS3=(.*)" $line m0 m1] {
	    set ParamConn(dns) "yes"
	    set ParamConn(dnsmode) "manu"
	    set ParamConn(dns3) $m1
	} else {
	    continue
	}
    }
    close $fid

    # read chat file 
    set fid ""
    catch {set fid [open $filchat r]} err
    if { $fid == "" } {
	return $err
    }
    gets $fid line
    while { [string compare $line "ABORT"] == 0 || \
	    [string compare $line "REPORT"] == 0 } {
	gets $fid line
	gets $fid line
    }
    gets $fid line
    set ParamConn(modem) $line
    gets $fid line
    gets $fid line
    regexp {ATD([PT])(.*)} $line m0 m1 m2
    if { $m1 == "T" } {
	set ParamConn(freq) 0
    } else {
	set ParamConn(freq) 1
    }
    set ParamConn(phone) $m2
    gets $fid line

    gets $fid line
    if { ! [eof $fid] } {
	set ParamConn(login) "yes"
	foreach key {send1 xpect1 send2 xpect2 send3 xpect3 send4 xpect4} {
	    if { $line == "\"\"" } { 
		set ParamConn($key) ""
	    } else {
		set tmp $line
		set ParamConn($key) [string trim $tmp {"}]
	    }
	    gets $fid line
	}
    } else {
	set ParamConn(login) "no"
	foreach key {send1 xpect1 send2 xpect2 send3 xpect3 send4 xpect4} {
	    set ParamConn($key) ""
	}
    }
    close $fid

    # read pap files
    if [ string compare $ParamConn(pap) "no" ] {
	if [ file exists $filpap ] {
	    set fid ""
	    catch {set fid [ open $filpap r]} err
	    if { $fid == "" } {
		return $err
	    }
	    gets $fid line
	    set ParamConn(user) $line
	    gets $fid line
	    set ParamConn(pass) $line
	    close $fid
	} else {
	    set ParamConn(pass) ""
	    set fid ""
	    catch {set fid [open $Files(PppPapSecrets) r]} err
	    if { $fid == "" } {
		return $err
	    }
	    set rtmp "^$ParamConn(user)\[ \t\]+(\[^ \t]+)\[ \t\]+(\[^ \t]+)"
	    while { ! [ eof $fid ] } {
		gets $fid line
		if [regexp $rtmp $line m0 m1 m2] {
		    set ParamConn(pass) $m2
		    break
		} else {
		    continue
		}
	    }
	    close $fid
	}
    } else {
	set ParamConn(user) ""
	set ParamConn(pass) ""
    }

    return ""
}

proc EditPapSecretsFile {opt ident passwd} {
    global Files

    set tmpf "/tmp/papsec[pid]"
    
    # use fcopy rather than file copy
    # to avoid error message with temporary file
    if [catch {set fid1 [ open $Files(PppPapSecrets) r ]} err] {
	return $err
    }
    if [catch {set fid2 [ open $tmpf w ]} err] {
	close $fid1
	return $err
    }
    fcopy $fid1 $fid2
    close $fid1
    close $fid2
    if [catch {set fid1 [ open $tmpf r ]} err] {
	return $err
    }
    if [catch {set fid2 [ open $Files(PppPapSecrets) w ]} err] {
	close $fid1
	return $err
    }
    set rtmp "^$ident\[ \t\]+(\[^ \t]+)\[ \t\]+(\[^ \t]+)"
    set done 0
    gets $fid1 line
    while { ! [ eof $fid1 ] } {
	if [regexp $rtmp $line m0 m1 m2] {
	    if [ string compare $opt "del" ] {
		puts $fid2 "$ident\t*\t$passwd"
		set done 1
	    }
	} else {
	    puts $fid2 $line
	}
	gets $fid1 line
    }
    if [ string compare $opt "del" ] {
	if { ! $done } {
	    puts $fid2 "$ident\t*\t$passwd"
	}
    }
    close $fid1
    close $fid2
    file delete $tmpf

    # make pap-secrets and chap-secrets identical !
    # use fcopy rather than file copy
    # to avoid error message with temporary file
    if [catch {set fid1 [ open $Files(PppPapSecrets) r ]} err] {
	return $err
    }
    if [catch {set fid2 [ open $Files(PppChapSecrets) w ]} err] {
	close $fid1
	return $err
    }
    fcopy $fid1 $fid2
    close $fid1
    close $fid2
    
    return ""
}

proc RedoPapSecretsFile {} {
    global Config Misc

    # recreate pap-secret file with saved pap files

    if { ![string compare $Misc(Use+ua) "no"] } {
	
	cd $Config(scriptdir)
	set lstpap [glob -nocomplain *.pap]

	foreach file $lstpap {
	    set fid ""
	    catch {set fid [ open $file r]} err
	    if { $fid == "" } {
		return $err
	    }
	    gets $fid userid
	    gets $fid passwd
	    close $fid
	    set err [ EditPapSecretsFile mod $userid $passwd ]
	    if [ string length $err ] {
		return $err
	    }
	}
    }
}

proc GetConnectionParams {} {
    global ParamConn
    
    set ParamConn(name) [.conx.f.fgen.enam get]
    set ParamConn(phone) [.conx.f.fgen.etel get]
    set ParamConn(freq) [.conx.f.fgen.mfrq.m index [ .conx.f.fgen.mfrq cget -text]]
    set tmp [.conx.f.fgen.eline get]
    set tmp0 [string index $tmp 0]
    if { $tmp0 == "/" }  {
	set ParamConn(line) $tmp
    } else {
	set ParamConn(line) [file join / dev $tmp]
    }
    set ParamConn(speed) [.conx.f.fgen.mspd cget -text]
    set ParamConn(modem) [.conx.f.fgen.eimod get]
    set ParamConn(ipadr) [.conx.f.fgen.eipad get]

    set ParamConn(send1) [.conx.f.flog.esnd1 get]
    set ParamConn(xpect1) [.conx.f.flog.expk1 get]
    set ParamConn(send2) [.conx.f.flog.esnd2 get]
    set ParamConn(xpect2) [.conx.f.flog.expk2 get]
    set ParamConn(send3) [.conx.f.flog.esnd3 get]
    set ParamConn(xpect3) [.conx.f.flog.expk3 get]
    set ParamConn(send4) [.conx.f.flog.esnd4 get]
    set ParamConn(xpect4) [.conx.f.flog.expk4 get]

    set ParamConn(user) [.conx.f.fpap.eusr get]
    set ParamConn(pass) [.conx.f.fpap.epass get]

    set ParamConn(domain) [.conx.f.fdns.edom get]
    set ParamConn(dns1) [.conx.f.fdns.edns1 get]
    set ParamConn(dns2) [.conx.f.fdns.edns2 get]
    set ParamConn(dns3) [.conx.f.fdns.edns3 get]
}

# useless , debug stuff
proc ShowConnectionParams {} {
    global ParamConn
    
    puts "name    $ParamConn(name)"
    puts "phone   $ParamConn(phone)"
    puts "freq    $ParamConn(freq)"
    puts "line    $ParamConn(line)"
    puts "speed   $ParamConn(speed)"
    puts "modem   $ParamConn(modem)"
    puts "ipadr   $ParamConn(ipadr)"
    puts "login   $ParamConn(login)"
    puts "send1   $ParamConn(send1)"
    puts "xpect1  $ParamConn(xpect1)"
    puts "send2   $ParamConn(send2)"
    puts "xpect2  $ParamConn(xpect2)"
    puts "send3   $ParamConn(send3)"
    puts "xpect3  $ParamConn(xpect3)"
    puts "send4   $ParamConn(send4)"
    puts "xpect4  $ParamConn(xpect4)"
    puts "pap     $ParamConn(pap)"
    puts "user    $ParamConn(user)"
    puts "pass    $ParamConn(pass)"
    puts "dns     $ParamConn(dns)"
    puts "dnsmode $ParamConn(dnsmode)"
    puts "domain  $ParamConn(domain)"
    puts "dns1    $ParamConn(dns1)"
    puts "dns2    $ParamConn(dns2)"
    puts "dns3    $ParamConn(dns3)"
}

proc GetConnectionStatus {} {
    global Misc ParamIP
    set Misc(ConState) "no"
    set Misc(CurrentSite) ""

    set ParamIP(if) ""
    set ParamIP(dev) ""
    set ParamIP(speed) ""
    set ParamIP(locip) ""
    set ParamIP(remip) ""
}

#############################################
# running pppd  ( real work)
#############################################
proc DoConnScript {sitnam} {
    global Files Config

    set filbase [ file join $Config(scriptdir) $sitnam ]

    close [open $Files(ConnectTraceFile) w]
    GenerateIPUpDownScripts
    exec $filbase [pid] &
}

proc DoDisconnScript {} {
    global Files

    if [ file exists $Files(PppLogFile) ] {
	set fid [open $Files(PppLogFile) r]
	gets $fid line
	close $fid
	exec kill $line
    }
}

proc WaitForConnected {} {
    global Files ParamIP Misc
    global Messages PppError Args
    
    if { $Misc(ConState) != "in" } {
	return
    }

    if { ! [ file exists $Files(ConnectTraceFile) ] } {
	AbortConnect
   	if [ file exists $Files(ErrorTraceFile) ] {
	    set fid [ open $Files(ErrorTraceFile) r]
	    gets $fid line
	    close $fid
	    file delete $Files(ErrorTraceFile)
	    set errmsg "$Messages(noconn) : $PppError($line)"
	} else {
	    set errmsg $Messages(noconn)
	}
	# do not diplay error in autokill mode
	if { [info exists Args(autokill)] } {
	    ShowError $errmsg 
	}
    } elseif [ file size $Files(ConnectTraceFile) ] {
   	set fid [ open $Files(ConnectTraceFile) r]
	while { ! [ eof $fid ] } {
	    gets $fid line
	    if [regexp "^INTERFACE=(.*)" $line m0 m1] {
		set ParamIP(if) $m1
	    } elseif [regexp "^LINE=(.*)" $line m0 m1] {
		set ParamIP(dev) $m1
	    } elseif [regexp "^SPEED=(.*)" $line m0 m1] {
		set ParamIP(speed) $m1
	    } elseif [regexp "^LOCALIP=(.*)" $line m0 m1] {
		set ParamIP(locip) $m1
	    } elseif [regexp "^REMOTEIP=(.*)" $line m0 m1] {
		set ParamIP(remip) $m1
	    } else {
		continue
	    }
	}
	close $fid
	SetConnected
    } else {
	after 100 WaitForConnected
    }
}

proc WaitForDisconnected {} {
    global Files Misc ParamIP
    
    if { $Misc(ConState) != "out" } {
	return
    }

    if [ file exists $Files(PppLogFile) ] {
	after 100 WaitForDisconnected
    } else {
	set ParamIP(if) ""
	set ParamIP(dev) ""
	set ParamIP(speed) ""
	set ParamIP(locip) ""
	set ParamIP(remip) ""
	SetDisconnected
    }
}

proc SurveyConnection {} {
    global Files Misc
    
    if { $Misc(ConState) != "yes" } {
	return
    }

    if [ file exists $Files(PppLogFile) ] {
	after 1000 SurveyConnection
    } else {
	DoDisconnect
    }
}

proc GenerateIPUpDownScripts {} {
    global Files

    # ip up script 
    set fid ""
    catch {set fid [open $Files(PppUpFile) w 0777]} err
    if { $fid == "" } {
	FatalError $err
    }
    puts $fid "#/bin/sh"
    puts $fid "#"
    puts $fid "if \[ -e $Files(ConnectTraceFile) \]"
    puts $fid "then"
    puts $fid " (" 
    puts $fid "  PARIP1=\$1" 
    puts $fid "  PARIP2=\$2" 
    puts $fid "  PARIP3=\$3" 
    puts $fid "  PARIP4=\$4" 
    puts $fid "  PARIP5=\$5" 
    puts $fid "  PARIP6=\$6" 
    puts $fid "  if \[ -s /tmp/VpppChatReport \]"
    puts $fid "  then"
    puts $fid "    TMPSPD=\$PARIP3"
    puts $fid "    LINE=`fgrep CONNECT /tmp/VpppChatReport`"
    puts $fid "    set \$LINE none"
    puts $fid "    while \[ \"\$1\" != \"\" -a \"\$1\" != \"CONNECT\" \]"
    puts $fid "    do"
    puts $fid "      shift"
    puts $fid "    done"
    puts $fid "    T2SPD=\$2"
    puts $fid "    if \[ \"\$T2SPD\" = \"\" -o \"\$T2SPD\" = \"none\" \]"
    puts $fid "    then"
    puts $fid "      T2SPD=\$TMPSPD"
    puts $fid "    fi"
    puts $fid "    rm -f /tmp/VpppChatReport"
    puts $fid "    echo \"SPEED=\$T2SPD\""
    puts $fid "  else"
    puts $fid "    echo \"SPEED=\$PARIP3\"" 
    puts $fid "  fi" 
    puts $fid "  echo \"INTERFACE=\$PARIP1\"" 
    puts $fid "  echo \"LINE=\$PARIP2\"" 
    puts $fid "  echo \"LOCALIP=\$PARIP4\"" 
    puts $fid "  echo \"REMOTEIP=\$PARIP5\"" 
    puts $fid "  echo \"PPPARG=\$PARIP6\"" 
    puts $fid " ) >> /tmp/vppp-tmp-[pid]" 
    puts $fid " cp /tmp/vppp-tmp-[pid] $Files(ConnectTraceFile)" 
    puts $fid " rm -f /tmp/vppp-tmp-[pid]" 
    puts $fid "fi"
    close $fid

    # ip down script 
    set fid ""
    catch {set fid [open $Files(PppDownFile) w 0777]} err
    if { $fid == "" } {
	FatalError $err
    }
    puts $fid "#/bin/sh"
    puts $fid "#"
    puts $fid "rm -f $Files(ConnectTraceFile)"
    close $fid
}

proc DeleteIPUpDownScripts {} {
    global Files

    # ip up script 
    if [ file exists $Files(PppUpFile)] {
	file delete $Files(PppUpFile)
    }

    # ip down script 
    if [ file exists $Files(PppDownFile)] {
	file delete $Files(PppDownFile)
    }
}

proc AutoKill {} {
    global Files

    if [ file exists $Files(KillTraceFile) ] {
	# let pppd some time to finish !
	after 2000
	VpppExit
    }
    after 1000 AutoKill
}

########################################################
#
# Advanced edit
#
#########################################################

proc AdvancedEdit {name} {
    global Files Config
    destroy .conx

    set curwd [pwd]
    cd $Config(scriptdir)
    set flst [glob -nocomplain $name*]
    cd $curwd
    set aflst {}
    foreach fil $flst {
	lappend aflst [ file join $Config(scriptdir) $fil]
    }
    ShowFiles $aflst
}


proc ShowFiles {filelst} {
    global Messages Misc

    if [ winfo exists .vfiles ] {
	return
    }

    toplevel .vfiles
    frame .vfiles.choix -borderwidth 2 -relief groove 
    menubutton .vfiles.choix.mefil -text "" -indicatoron 1 -relief raised \
	    -menu .vfiles.choix.mefil.m
    menu .vfiles.choix.mefil.m -tearoff 0
    foreach var $filelst {
	.vfiles.choix.mefil.m add command -label $var \
		-command "ChangeFile $var"
    }
    entry .vfiles.choix.enfil -background $Misc(EntryColor)
    bind .vfiles.choix.enfil <Key-Return> "PressEnter"
    bind .vfiles.choix.enfil <Key-KP_Enter> "PressEnter"
    pack .vfiles.choix -side top -fill x
    pack .vfiles.choix.mefil -side left -fill y -pady 4 -padx 4
    pack .vfiles.choix.enfil -side left -fill both -pady 4 -expand 1 -padx 4
    
    frame .vfiles.butts -borderwidth 2 -relief groove
    button .vfiles.butts.save -text "$Messages(msgsvg)" -command SaveShowFiles
    button .vfiles.butts.xit -text "$Messages(msgcan)" -command CancelShowFiles
    pack .vfiles.butts -side bottom -fill x
    pack .vfiles.butts.save -side left -padx 6 -pady 4
    pack .vfiles.butts.xit -side left -padx 6 -pady 4
    
    frame .vfiles.fh -borderwidth 0
    pack .vfiles.fh -side top -expand 1 -fill both
    text .vfiles.fh.txt -wrap none \
	    -yscrollcommand ".vfiles.fh.sbv set" \
	    -xscrollcommand ".vfiles.fh.sbh set" 
    scrollbar .vfiles.fh.sbv -command ".vfiles.fh.txt yview"
    scrollbar .vfiles.fh.sbh -orient horizontal \
	    -command ".vfiles.fh.txt xview"
    button .vfiles.fh.sbx -text " " -borderwidth 1 -command {
	.vfiles.fh.txt xview moveto 0
	.vfiles.fh.txt yview moveto 0
    }
    set scw 16
    place .vfiles.fh.txt -x 4 -relwidth 1.0 -width [expr -$scw - 8 ] \
	    -y 4  -relheight 1.0 -height [ expr -$scw - 8 ]
    place .vfiles.fh.sbv -relx 1.0 -x [expr -$scw - 4 ] -width $scw \
	    -y 4  -relheight 1.0 -height [ expr -$scw - 8 ]
    place .vfiles.fh.sbh -rely 1.0 -y [expr -$scw - 4 ] -height $scw \
	    -x 4  -relwidth 1.0 -width [ expr -$scw - 8 ]
    place .vfiles.fh.sbx -rely 1.0 -y [expr -$scw - 4 ] -height $scw \
	    -relx 1.0 -x [expr -$scw - 4 ] -width $scw
    
    wm geometry .vfiles 500x400
    wm title .vfiles $Messages(xtitle) 

    set_balloon  .vfiles.choix.mefil $Messages(b_scr) 
    set_balloon  .vfiles.choix.enfil $Messages(b_sfl) 

    ChangeFile [lindex $filelst 0]
}

proc ChangeFile {entry} {
    global Messages

    .vfiles.choix.enfil delete 0 end 
    .vfiles.choix.enfil insert 0 $entry 

    set fid ""
    catch {set fid [open $entry r]} err
    if { $fid != "" } {
	.vfiles.fh.txt delete 0.0 end  
	gets $fid line
	while { ! [eof $fid] } {
	    .vfiles.fh.txt insert end "$line\n"
	    gets $fid line
	}
	close $fid
    } else {
	tk_messageBox -title $Messages(error) -message "$Messages(notread)\n$err" \
		-icon error -type ok -parent .vfiles
    }
}

proc SaveShowFiles {} {
    global Messages

    set file [.vfiles.choix.enfil get]

    set fid ""
    catch {set fid [open $file w]} err
    if { $fid != "" } {
	set tmp [.vfiles.fh.txt get 0.0 end]
	puts $fid $tmp
	close $fid
    } else {
	tk_messageBox -title $Messages(error) -message "$Messages(notwrite)\n$err" \
		-icon error -type ok -parent .vfiles
    }
}

proc CancelShowFiles {} {
    destroy .vfiles
}

proc PressEnter {} {
    set file [.vfiles.choix.enfil get]

    ChangeFile $file
}

########################################################
#
# save/load scripts
#
#########################################################

proc ScriptsLoad {} {
    global env Config Messages Misc

    set fload [tk_getOpenFile -initialdir $env(HOME) -title $Messages(m1load) ]
    if { $fload != "" } {
	cd $Config(scriptdir)
	exec tar xvzf $fload
	RedoPapSecretsFile
	GetSiteList
    }
}

proc ScriptsSave {} {
    global env Config Messages

    set sitnam [GetSelectedSite]
    if { $sitnam == "" } {
	set tosave "*"
    } else {
	set tosave "$sitnam*"
    }

    set fsave [tk_getSaveFile -initialdir $env(HOME) -title $Messages(m1save) ]
    if { $fsave != "" } {
	cd $Config(scriptdir)
	exec sh << "tar cvzf $fsave $tosave"
    }
}

########################################################
#
# On line Help 
#
#########################################################

proc Help {head file} {
    global Files Config

    set Lang [GetLang]

    set fhlp [file join $Files(VpppLib) doc "$file.$Lang" ]
    if [ file isfile $fhlp] {
	ShowHelp "$head :" $fhlp
    } else {
	set fhlp [file join $Files(VpppLib) doc "$file.GB" ]
	if [ file isfile $fhlp] {
	    ShowHelp "$head :" $fhlp
	}
    }
}

proc ShowHelp {head file} {
 global Messages Misc

 if { ! [ winfo exists .onlhelp ] } {
   toplevel .onlhelp
   label .onlhelp.head -text "head" -anchor nw -pady 4 -foreground yellow
   pack .onlhelp.head -side top -fill x
   button .onlhelp.xit -text "$Messages(msgok)" -command {destroy .onlhelp}
   pack .onlhelp.xit -side bottom -pady 4
   frame .onlhelp.fh -borderwidth 0
   pack .onlhelp.fh -side top -expand 1 -fill both
   text .onlhelp.fh.txt -wrap none \
	 -yscrollcommand ".onlhelp.fh.sbv set" \
	 -xscrollcommand ".onlhelp.fh.sbh set" \
	 -font 9x15 -background $Misc(EntryColor)
   scrollbar .onlhelp.fh.sbv -command ".onlhelp.fh.txt yview"
   scrollbar .onlhelp.fh.sbh -orient horizontal \
	-command ".onlhelp.fh.txt xview"
   button .onlhelp.fh.sbx -text " " -borderwidth 1 -command {
    .onlhelp.fh.txt xview moveto 0
    .onlhelp.fh.txt yview moveto 0
   }
   set scw 16
   place .onlhelp.fh.txt -x 4 -relwidth 1.0 -width [expr -$scw - 8 ] \
 	-y 4  -relheight 1.0 -height [ expr -$scw - 8 ]
   place .onlhelp.fh.sbv -relx 1.0 -x [expr -$scw - 4 ] -width $scw \
	-y 4  -relheight 1.0 -height [ expr -$scw - 8 ]
   place .onlhelp.fh.sbh -rely 1.0 -y [expr -$scw - 4 ] -height $scw \
	-x 4  -relwidth 1.0 -width [ expr -$scw - 8 ]
   place .onlhelp.fh.sbx -rely 1.0 -y [expr -$scw - 4 ] -height $scw \
	-relx 1.0 -x [expr -$scw - 4 ] -width $scw

   wm title .onlhelp $Messages(htitle) 
   wm geometry .onlhelp 550x500
 }

 set fid [open $file r]
 if [ string length $fid ] {
   .onlhelp.fh.txt delete 0.0 end  
   .onlhelp.head configure -text $head
   gets $fid line
   while { ! [eof $fid] } {
     .onlhelp.fh.txt insert end "$line\n"
     gets $fid line
   }
   close $fid
 }

}

#########################################################
# options stuff
#########################################################
proc SetLng {} {
    global Messages Config Temp

    if [ winfo exists .lng ] {
	return
    }

    toplevel .lng
    wm title .lng $Messages(m3lng)
    
    set Temp(tmplng) $Config(lng)

    frame .lng.f1 -borderwidth 0 
    pack .lng.f1 -padx 2 -pady 2 -expand 1 -fill both

    frame .lng.btf -borderwidth 2 -relief groove
    pack .lng.btf -padx 0 -pady 0 -fill x

    button .lng.btf.ok -text $Messages(msgok) -command { OkLng }
    button .lng.btf.no -text $Messages(msgcan) -command { 
	destroy .lng
    }
    
    pack .lng.btf.ok .lng.btf.no -side left -padx 8 -pady 4

    set frm .lng.f1
    grid columnconf $frm 0 -weight 1
    grid columnconf $frm 1 -weight 2
    grid rowconf $frm 3 -weight 1

    label $frm.lb -text $Messages(lng) -anchor w
    grid $frm.lb -row 0 -column 0 -sticky nsew -padx 6 -pady 0

    frame $frm.fl -borderwidth 0 -relief flat
    grid $frm.fl -row 0 -column 1 -sticky nsew -padx 6 -pady 0

    menubutton $frm.fl.mb -textvariable Temp(tmplng) \
	    -indicatoron 1 -relief raised -menu $frm.fl.mb.m
    menu $frm.fl.mb.m -tearoff 0
    $frm.fl.mb.m add command -label "-- (LANG/LC_ALL)" \
	 -command "set Temp(tmplng) {--}"
    $frm.fl.mb.m add command -label "GB" \
	 -command "set Temp(tmplng) {GB}"
    set lnglst [ GetLangList ]
    foreach lng $lnglst {
	$frm.fl.mb.m add command -label "$lng" \
		-command "set Temp(tmplng) $lng"
    }
    pack $frm.fl.mb -side left -padx 2 -pady 2 

}
    
proc SetScriptDir {} {
    global Messages Config env

    if [ winfo exists .sdir ] {
	return
    }

    toplevel .sdir
    wm title .sdir $Messages(sdir)
    #wm geometry .sdir 300x80
    
    frame .sdir.f1 -borderwidth 0 
    pack .sdir.f1 -padx 2 -pady 2 -expand 1 -fill both

    frame .sdir.btf -borderwidth 2 -relief groove
    pack .sdir.btf -padx 0 -pady 0 -fill x

    button .sdir.btf.ok -text $Messages(msgok) -command { OkScriptDir }
    button .sdir.btf.no -text $Messages(msgcan) -command { 
	destroy .sdir
    }
    
    pack .sdir.btf.ok .sdir.btf.no -side left -padx 8 -pady 4

    entry .sdir.f1.ent -width 40
    button .sdir.f1.but -text $Messages(parc) -command {
	set tmp [tk_getDirectory -initialdir $env(HOME)]
	if [ string length $tmp ] {
	    .sdir.f1.ent delete 0 end
	    .sdir.f1.ent insert end $tmp
	}
    }
    pack .sdir.f1.ent -side left -padx 4 -pady 10 -fill x -expand 1
    pack .sdir.f1.but -side right -padx 4 -pady 10 

    .sdir.f1.ent insert end $Config(scriptdir)
}
    
proc GetLangList {} {
    global Files
    
    cd $Files(VpppLib)
    set ficlst [ glob -nocomplain message.* ]
    set lnglst {}
    foreach fic $ficlst {
	lappend lnglst [string trimleft [file extension $fic] .]
    }
    return $lnglst
}

proc OkLng {} {
    global Config Temp

    set Config(lng) $Temp(tmplng)
    destroy .lng
}

proc OkScriptDir {} {
    global Config

    set Config(scriptdir) [.sdir.f1.ent get]
    GetSiteList
    RedoPapSecretsFile
    destroy .sdir
}

#########################################################
# configuration stuff
#########################################################
proc InitDefaultConfig {} {
    global Config env

    set Config(scriptdir) [file join $env(HOME) ".vpppscripts"]
    set Config(lng) "GB"
    set Config(sortby) "dat0"
    set Config(timcumul) 0
    set Config(timode) "current"
    set Config(datcumul) [clock seconds]
}

proc WriteConfig {} {
    global Config Files

    set fid [open $Files(VpppRcFile) w]
    puts $fid "# vppp generated config file"
    puts $fid "#"

    set clst [array names Config]
    foreach elem $clst {
	puts $fid "set Config($elem) \{$Config($elem)\}"
    }
    close $fid
}

proc ReadConfig {} {
    global Config Files

    source $Files(VpppRcFile)
}

proc AutoSave {} {
    WriteConfig
    after 60000 AutoSave
}

proc GetLang {} {
    global Config env

    if { ![ string compare $Config(lng) "--" ]} { 
	if [ info exists env(LANG) ] {
	    set lang [string toupper [string range $env(LANG) 0 1]]
	} elseif [ info exists env(LC_ALL) ] {
	    set lang [string toupper [string range $env(LC_ALL) 0 1]]
	} else {
	    set lang "GB"
	}
    } else {
	set lang $Config(lng)
    }
    return $lang
}

#########################################################
# ppp scripts stuff
# try to adapt various ip-up/down script to vppp's need
#########################################################
proc VerifyPppScripts {} {

    set IpUpScript "/etc/ppp/ip-up"
    set IpDownScript "/etc/ppp/ip-down"
    set IpUpLocalScript "/etc/ppp/ip-up.local"
    set IpDownLocalScript "/etc/ppp/ip-down.local"

    set AddLineUp "test -x /etc/ppp/ip-up.vppp && /etc/ppp/ip-up.vppp \$*"
    set AddLineDown "test -x /etc/ppp/ip-down.vppp && /etc/ppp/ip-down.vppp \$*"

    if { ![ file exists $IpUpScript ] } {

	# ip-up script does not exists 
	# -> create it and make it call ip-up.vppp

	set fid ""
	catch {set fid [ open $IpUpScript w 0777]} err
	if { $fid == "" } {
	    FatalError $err
	}
	puts $fid "#!/bin/sh"
	puts $fid ""
	puts $fid "# This file should not be modified"
	puts $fid "# add local changes to /etc/ppp/ip-up.d/xxx instead"
	puts $fid ""
	puts $fid $AddLineUp
	puts $fid ""
	puts $fid "exit 0"
	close $fid

    } elseif { ![ file exists $IpUpLocalScript ] } {

	# ip-up.local script does not exists 
	# -> create it and make it call ip-up.vppp

	set fid ""
	catch {set fid [ open $IpUpLocalScript w 0777]} err
	if { $fid == "" } {
	    FatalError $err
	}
	puts $fid "#!/bin/sh"
	puts $fid ""
	puts $fid "# just call ip-up.vppp. you can add your own stuff here"
	puts $fid "# or in /etc/ppp/ip-up.d/xxx "
	puts $fid ""
	puts $fid $AddLineUp
	puts $fid ""
	puts $fid "exit 0"
	close $fid

	# now remove previouly installed call to ip-up.vppp 
	# in ip-up ( old version ) , it is better to do it only in
	# ip-up.local

	set linipup [ReadFile $IpUpScript]
	set indx [lsearch -regexp $linipup {/etc/ppp/ip-up.vppp}]
        if { $indx != -1 } {
	    set linipup [lreplace $linipup $indx $indx]
	    WriteFile $IpUpScript $linipup
	}

    } else {

	# ip-up and ip-up.local both exists
	# verify that ip-up.local call ip-up.vppp
	# and add it if not the case

	set linipupl [ReadFile $IpUpLocalScript]
	set indx [lsearch -regexp $linipupl {/etc/ppp/ip-up.vppp}]
        if { $indx == -1 } {
	    lappend linipupl $AddLineUp
	    WriteFile $IpUpLocalScript $linipupl
	}
    }

    if { ![ file exists $IpDownScript ] } {

	# ip-down script does not exists 
	# -> create it and make it call ip-down.vppp

	set fid ""
	catch {set fid [ open $IpDownScript w 0777]} err
	if { $fid == "" } {
	    FatalError $err
	}
	puts $fid "#!/bin/sh"
	puts $fid ""
	puts $fid "# just call ip-down.vppp. you can add your own stuff here"
	puts $fid "# or in /etc/ppp/ip-down.d/xxx "
	puts $fid ""
	puts $fid $AddLineDown
	puts $fid ""
	puts $fid "exit 0"
	close $fid

    } elseif { ![ file exists $IpDownLocalScript ] } {

	# ip-down.local script does not exists 
	# -> create it and make it call ip-down.vppp

	set fid ""
	catch {set fid [ open $IpDownLocalScript w 0777]} err
	if { $fid == "" } {
	    FatalError $err
	}
	puts $fid "#!/bin/sh"
	puts $fid ""
	puts $fid "# This file should not be modified"
	puts $fid "# add local changes to /etc/ppp/ip-down.d/xxx instead"
	puts $fid ""
	puts $fid $AddLineDown
	puts $fid ""
	puts $fid "exit 0"
	close $fid

	# now remove previouly installed call to ip-down.vppp 
	# in ip-down ( old version ) , it is better to do it only in
	# ip-down.local

	set linipdn [ReadFile $IpDownScript]
	set indx [lsearch -regexp $linipdn {/etc/ppp/ip-down.vppp}]
        if { $indx != -1 } {
	    set linipdn [lreplace $linipdn $indx $indx]
	    WriteFile $IpDownScript $linipdn
	}

    } else {

	# ip-down and ip-down.local both exists
	# verify that ip-down.local call ip-down.vppp
	# and add it if not the case

	set linipdnl [ReadFile $IpDownLocalScript]
	set indx [lsearch -regexp $linipdnl {/etc/ppp/ip-down.vppp}]
        if { $indx == -1 } {
	    lappend linipdnl $AddLineDown
	    WriteFile $IpDownLocalScript $linipdnl
	}

    }
}

# read file in a list
proc ReadFile {fpath} {
    set fid ""
    catch {set fid [ open $fpath r]} err
    if { $fid == "" } {
	FatalError $err
    }
    set lines ""
    gets $fid line
    while { ! [ eof $fid ] } {
	lappend lines $line
	gets $fid line
    }
    close $fid

    return $lines
}

# write file from a list
proc WriteFile {fpath lines} {
    set fid ""
    catch {set fid [ open $fpath w 0777]} err
    if { $fid == "" } {
	FatalError $err
    }
    foreach line $lines {
	puts $fid $line
    }
    close $fid
}

########################################################
# parse arguments 
#########################################################

proc Usage {} {
    puts "vppp \[--help\] \[--script name\] \[--go\] \[--autokill\] \[--exec prog\] \\"
    puts "     \[--geometry WxH+X+Y\] \[--iconic\] \[--hidden\] "
    puts " where :"
    puts " --help             : show this help"
    puts " --script name      : use name as current connection script"
    puts " --go               : immediately launch the connection "
    puts " --exec prog        : execute prog once connected "
    puts " --autokill         : automatically kill vppp when pppd terminate "
    puts " --geometry WxH+X+Y : use this geometry for the main window "
    puts " --iconic           : start iconified "
    puts " --hidden           : do not show the GUI"
    exit
}

proc ParseArgs {} {
    global Args argc argv

    set Args(count) $argc

    while { $argc != 0 } {
	set arg1 [lindex $argv 0]
	switch -regexp -- $arg1 {
	    "^-+script$" {
		set Args(script) [lindex $argv 1]
		set argv [ lrange $argv 2 end]
		set argc [ llength $argv ]
	    }
	    "^-+h(elp)*$" {
		Usage
	    }
	    "^-+go$" {
		set Args(go) "yes"
		set argv [ lrange $argv 1 end]
		set argc [ llength $argv ]
	    }
	    "^-+exec$" {
		set Args(exec) [lindex $argv 1]
		set argv [ lrange $argv 2 end]
		set argc [ llength $argv ]
	    }
	    "^-+auto(kill)*$" {
		set Args(autokill) "yes"
		set argv [ lrange $argv 1 end]
		set argc [ llength $argv ]
	    }
	    "^-+geom(etry)*$" {
		set Args(geom) [lindex $argv 1]
		set argv [ lrange $argv 2 end]
		set argc [ llength $argv ]
	    }
	    "^-+icon(ic)*$" {
		set Args(iconic) "yes"
		set argv [ lrange $argv 1 end]
		set argc [ llength $argv ]
	    }
	    "^-+hidden$" {
		set Args(hidden) "yes"
		set argv [ lrange $argv 1 end]
		set argc [ llength $argv ]
	    }
	    default {
		Usage
	    }
	}
    }
}  

########################################################
#
# MAIN 
#
#########################################################

ParseArgs

InitDefaultConfig
if { ![ file exists $Files(VpppRcFile) ]} {
    WriteConfig
} else {
    ReadConfig
}

ReadMessagesFile

CreateWidgets

VerifyPppScripts

GetConnectionStatus

GetSiteList

AutoSave

# manage automatic actions specified by args

if { [info exists Args(script)] } {
    set max [.main.fl.lst size]
    for { set ind 0} { $ind < $max } { incr ind } {
	set elem [.main.fl.lst get $ind ]
        if { ! [string compare [lindex $elem 0] $Args(script) ] } {
	    .main.fl.lst selection set $ind
	    .main.fl.lst see $ind
	    ViewTime refresh
	    break
	}
    }
}

if { [info exists Args(exec)] } {

    set fid ""
    catch {set fid [open $Files(PppExecFile) w 0777]} err
    if { $fid == "" } {
	FatalError $err
    }
    puts $fid "#/bin/sh"
    puts $fid "#"
    puts $fid "$Args(exec)"
    close $fid
}

if { [info exists Args(autokill)] } {

    set fid ""
    catch {set fid [open $Files(PppKillFile) w 0777]} err
    if { $fid == "" } {
	FatalError $err
    }
    puts $fid "#/bin/sh"
    puts $fid "#"
    puts $fid "echo > $Files(KillTraceFile)"
    close $fid

    AutoKill
}

if { [info exists Args(go)] } {
    DoIt
}

